/****************************************************************/
/*																*/
/*  AboutCtrl.cpp												*/
/*																*/
/*  Implementation of the CAboutCtrl.cpp class.					*/
/*																*/
/*  Programmed by Pablo van der Meer							*/
/*  Copyright Pablo Software Solutions 2002						*/
/*  http://www.pablovandermeer.nl								*/
/*																*/
/*  Last updated: 28 june 2002									*/
/*																*/
/****************************************************************/


#include "stdafx.h"
#include "resource.h"
#include "AboutCtrl.h"
#include "SeekDialog.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CAboutCtrl::CAboutCtrl()
{
	m_hCreditsDC = NULL;
	m_hBackgroundDC = NULL;
	m_hMemDC = NULL;
}


CAboutCtrl::~CAboutCtrl()
{
	// clean up
	if (m_hCreditsDC != NULL)
		DeleteDC(m_hCreditsDC);
	if (m_hBackgroundDC != NULL)
		DeleteDC(m_hBackgroundDC);
	if (m_hMemDC != NULL)
		DeleteDC(m_hMemDC);
}


BEGIN_MESSAGE_MAP(CAboutCtrl, CStatic)
	//{{AFX_MSG_MAP(CAboutCtrl)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/********************************************************************/
/*																	*/
/* Function name : Initialize										*/
/* Description   : Initialize some stuff							*/
/*																	*/
/********************************************************************/
void CAboutCtrl::Initialize()
{
	int cx, cy;

	m_cxData = 220;
	m_cyData = 320;

	CRect rect;
	GetClientRect(rect);

	CDC* pDC = GetDC();

	// create credits dc
	LoadCredits(m_hCreditsDC, m_cxData, m_cyData, pDC->m_hDC);
	LoadPicture(IDB_BACKGROUND, m_hBackgroundDC, cx, cy, pDC->m_hDC); 

	HDC hdcB = CreateCompatibleDC(m_hBackgroundDC);
	HBITMAP bmB = CreateCompatibleBitmap(m_hBackgroundDC, rect.Width(), rect.Height());
	SelectObject(hdcB, bmB);
	// Load Backgroundpicture and creates background DC
	LoadPicture(IDB_BACKGROUND, hdcB, cx, cy, pDC->m_hDC); 

	COLORREF cColor = SetBkColor(hdcB, RGB(255, 0, 255));

	CRect tmp = rect;
	tmp.right = tmp.left + 194;
	SeekDialog->DrawGradient(CDC::FromHandle(m_hBackgroundDC), pMainFrame->mySkin.startColor, pMainFrame->mySkin.endColor, &tmp);
	tmp = rect;
	tmp.left += 194;
	CDC::FromHandle(m_hBackgroundDC)->FillSolidRect(&tmp, pMainFrame->mySkin.endColor);

	HDC hdc1 = CreateCompatibleDC(m_hBackgroundDC);
	HDC hdc2 = CreateCompatibleDC(m_hBackgroundDC);
	HDC hdc3 = CreateCompatibleDC(m_hBackgroundDC);
	HDC hdc4 = CreateCompatibleDC(m_hBackgroundDC);
	//Masque binaire
	HBITMAP bm1 = CreateBitmap(rect.Width(), rect.Height(), 1, 1, NULL);
	HBITMAP bm2 = CreateBitmap(rect.Width(), rect.Height(), 1, 1, NULL);
	HBITMAP bm3 = CreateCompatibleBitmap(hdcB, rect.Width(), rect.Height());
	HBITMAP bm4 = CreateCompatibleBitmap(hdcB, rect.Width(), rect.Height());
	SelectObject(hdc1, bm1);
	SelectObject(hdc2, bm2);
	SelectObject(hdc3, bm3);
	SelectObject(hdc4, bm4);

	//Image Original
	StretchBlt(hdc1, 0, 0, rect.Width(), rect.Height(), hdcB, 0, 0, rect.Width(), rect.Height(), SRCCOPY);
	//Image invers
	StretchBlt(hdc2, 0, 0, rect.Width(), rect.Height(), hdcB, 0, 0, rect.Width(), rect.Height(), NOTSRCCOPY);

	StretchBlt(hdc3, 0, 0, rect.Width(), rect.Height(), m_hBackgroundDC, 0, 0, rect.Width(), rect.Height(), SRCCOPY);
	StretchBlt(hdc4, 0, 0, rect.Width(), rect.Height(), hdcB, 0, 0, rect.Width(), rect.Height(), SRCCOPY);
	//Fond Orignal
	//Et entre Image invers et fond
	BitBlt(hdc3, 0, 0, rect.Width(), rect.Height(), hdc1, 0, 0, SRCAND);
	BitBlt(hdc4, 0, 0, rect.Width(), rect.Height(), hdc2, 0, 0, SRCAND);
	//Ou entre les 2 images obtenu
	BitBlt(hdc4, 0, 0, rect.Width(), rect.Height(), hdc3, 0, 0, SRCPAINT);
	BitBlt(m_hBackgroundDC, 0, 0, rect.Width(), rect.Height(), hdc4, 0, 0, SRCCOPY);

	DeleteDC(hdc1);
	DeleteObject(bm1);
	DeleteDC(hdc2);
	DeleteObject(bm2);
	DeleteDC(hdc3);
	DeleteObject(bm3);
	DeleteDC(hdc4);
	DeleteObject(bm4);









	//	BitBlt(m_hBackgroundDC, 0, 0, rect.Width(), rect.Height(), hdc1, 0, 0, SRCAND);

	DeleteDC(hdcB);
	DeleteObject(bmB);

	// create work area
	LoadPicture(0, m_hMemDC, cx, cy, pDC->m_hDC);

	// set scroll counter
	m_nCounter = rect.Height();

	ReleaseDC(pDC);
}


/********************************************************************/
/*																	*/
/* Function name : PreSubclassWindow								*/
/* Description   : Called before the window is subclassed.			*/
/*																	*/
/********************************************************************/
void CAboutCtrl::PreSubclassWindow()
{
	// initialze dc's
	Initialize();	
	// start animation
	SetTimer(1, 40, NULL);

	CStatic::PreSubclassWindow();
}


/********************************************************************/
/*																	*/
/* Function name : OnTimer											*/
/* Description   : Update display									*/
/*																	*/
/********************************************************************/
void CAboutCtrl::OnTimer(UINT nIDEvent)
{
	if (nIDEvent == 1)
	{
		AnimateLogo();
	}

	CStatic::OnTimer(nIDEvent);
}


/********************************************************************/
/*																	*/
/* Function name : AnimateLogo										*/
/* Description   : Animate 'flying' logo							*/
/*																	*/
/********************************************************************/
void CAboutCtrl::AnimateLogo()
{
	CRect rect;
	GetClientRect(rect);

	// copy background in memory bitmap
	BitBlt(m_hMemDC, 0, 0, rect.Width(), rect.Height(), m_hBackgroundDC, 0, 0, SRCCOPY);

	int yPos = m_cyData - m_nCounter - 100;

	// copy credits in memory dc
	BitBlt(m_hMemDC, 194, m_nCounter--, m_cxData, yPos, m_hCreditsDC, 0, 0, SRCAND);

	if (m_nCounter < -200)
	{
		m_nCounter = rect.Height();
	}

	CDC* pDC = GetDC();

	// and finally, copy memory bitmap to screen
	BitBlt(pDC->m_hDC, 0, 0, rect.Width(), rect.Height(), m_hMemDC, 0, 0, SRCCOPY);

	ReleaseDC(pDC);
}


/********************************************************************/
/*																	*/
/* Function name : LoadPicture										*/
/* Description   : Load picture from resource into device context	*/
/*																	*/
/********************************************************************/
void CAboutCtrl::LoadPicture(int nResourceID, HDC& hDestinationDC, int& nWidth, int& nHeight, HDC hDC)
{
	HDC hMemDC;
	HDC hdcCompatible;
	HBITMAP hbmScreen;

	if (nResourceID != 0)
	{
		// if resourceid is given, load bitmap
		HBITMAP hPicture = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(nResourceID));

		BITMAP bm;
		GetObject(hPicture, sizeof(BITMAP), (LPSTR)&bm);

		hMemDC = CreateCompatibleDC(hDC);

		HBITMAP hOldBMP = (HBITMAP)SelectObject(hMemDC, hPicture);

		nWidth = bm.bmWidth;
		nHeight = bm.bmHeight;

		// Create the DC
		hdcCompatible = CreateCompatibleDC(hDC);	
		// Temporary memory bitmap
		hbmScreen = CreateCompatibleBitmap(hDC, nWidth, nHeight);

		// select bitmap into dc
		if (SelectObject(hdcCompatible, hbmScreen) == NULL)
		{
			// return null
			hDestinationDC = NULL;
		}
		else
		{
			// return the DC
			hDestinationDC = hdcCompatible;
		}

		if (hDestinationDC)
			BitBlt(hDestinationDC, 0, 0, nWidth, nHeight, hMemDC, 0, 0, SRCCOPY);

		SelectObject(hMemDC, hOldBMP);

		// Release temporary stuff
		DeleteDC(hMemDC);
		DeleteObject(hbmScreen);
		DeleteObject(hPicture);
	}
	else	// if no resourceid is given, create empty DC with specified width and height
	{
		// create the DC
		hdcCompatible = CreateCompatibleDC(hDC);			
		// temporary memory bitmap
		hbmScreen = CreateCompatibleBitmap(hDC, nWidth, nHeight);		
		// if the function fails
		if (SelectObject(hdcCompatible, hbmScreen) == NULL)
		{
			// return null
			hDestinationDC = NULL;
		}
		else
		{
			// if it succeeds, return the DC
			hDestinationDC = hdcCompatible;
		}
		DeleteObject(hbmScreen);
	}
}


/********************************************************************/
/*																	*/
/* Function name : LoadCredits										*/
/* Description   : Create credits picture into device context		*/
/*																	*/
/********************************************************************/
void CAboutCtrl::LoadCredits(HDC& hDestinationDC, int nWidth, int nHeight, HDC hDC)
{
	HDC hdcCompatible;
	HBITMAP hbmScreen;

	// Create the DC
	hdcCompatible = CreateCompatibleDC(hDC);			
	// Temporary bitmap
	hbmScreen = CreateCompatibleBitmap(hDC, nWidth, nHeight);		
	// if the function fails
	if (SelectObject(hdcCompatible, hbmScreen) == NULL)
	{
		// return null
		hDC = NULL;
	}
	else
	{
		// if it succeeds, return the DC
		hDestinationDC = hdcCompatible;
		RECT rc;

		rc.top = 0;
		rc.left = 0;
		rc.bottom = nHeight;
		rc.right = nWidth;

		HFONT pOldFont;
		HFONT hFontTahoma, hFontBold, hFontNormal;
		FillRect(hDestinationDC, &rc, (HBRUSH)GetStockObject(WHITE_BRUSH));

		// create a bunch of fonts
		hFontTahoma = CreateFont(20, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY,
								 VARIABLE_PITCH | 0x04 | FF_DONTCARE, (LPSTR)"Arial");

		hFontBold = CreateFont(14, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY,
							   VARIABLE_PITCH | 0x04 | FF_DONTCARE, (LPSTR)"Arial");

		hFontNormal = CreateFont(14, 0, 0, 0, FALSE, FALSE, FALSE, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY,
								 VARIABLE_PITCH | 0x04 | FF_DONTCARE, (LPSTR)"Arial");


		CString strSub;
		int nCount = 0;
		// draw each line, based on specified type
		while (AfxExtractSubString(strSub, m_strCredits, nCount++, '\n'))
		{
			TCHAR nType = 0;
			COLORREF oldColor;

			if (!strSub.IsEmpty())
				nType = strSub.GetAt(0);

			switch (nType)
			{
			case '\t':
				// title
				oldColor = SetTextColor(hDestinationDC, RGB(16, 140, 231));
				pOldFont = (HFONT)SelectObject(hDestinationDC, hFontTahoma);
				strSub.TrimLeft('\t');
				DrawText(hDestinationDC, strSub, strSub.GetLength(), &rc, DT_TOP | DT_LEFT | DT_NOPREFIX | DT_SINGLELINE);
				break;
			case '\r':
				// bold
				oldColor = SetTextColor(hDestinationDC, RGB(0, 0, 0));
				pOldFont = (HFONT)SelectObject(hDestinationDC, hFontBold);
				strSub.TrimLeft('\r');
				DrawText(hDestinationDC, strSub, strSub.GetLength(), &rc, DT_TOP | DT_LEFT | DT_NOPREFIX | DT_SINGLELINE);
				break;
			case '\b':
				oldColor = SetTextColor(hDestinationDC, RGB(0, 0, 0));
				pOldFont = (HFONT)SelectObject(hDestinationDC, hFontNormal);
				strSub.TrimLeft('\b');
				DrawText(hDestinationDC, strSub, strSub.GetLength(), &rc, DT_TOP | DT_LEFT | DT_NOPREFIX | DT_SINGLELINE);
				break;
			default:
				// normal
				oldColor = SetTextColor(hDestinationDC, RGB(0, 0, 0));
				pOldFont = (HFONT)SelectObject(hDestinationDC, hFontNormal);
				DrawText(hDestinationDC, strSub, strSub.GetLength(), &rc, DT_TOP | DT_LEFT | DT_NOPREFIX | DT_SINGLELINE);
				break;
			}
			// next line
			TEXTMETRIC tm;  
			GetTextMetrics(hDestinationDC, &tm);
			rc.top += tm.tmHeight;

			// set back old values
			SetTextColor(hDestinationDC, oldColor);
			SelectObject(hDestinationDC, pOldFont);
		}
		// clean up
		DeleteObject(hFontBold);
		DeleteObject(hFontNormal);
		DeleteObject(hFontTahoma);
	}
	DeleteObject(hbmScreen);
}


/********************************************************************/
/*																	*/
/* Function name : SetCredits										*/
/* Description   : Member function to set credits text.				*/
/*																	*/
/********************************************************************/
void CAboutCtrl::SetCredits(LPCTSTR lpszCredits)
{
	m_strCredits = lpszCredits;
}
