// EqualizerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "SysTrayPlay.h"
#include "MainWnd.h"
#include "EqualizerDlg.h"
#include "PRName.h"
#include "MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CMyEQBar,CProgressCtrl)
  ON_WM_LBUTTONDOWN()
  ON_WM_MOUSEMOVE()
  ON_WM_PAINT()
  ON_WM_ERASEBKGND( )
END_MESSAGE_MAP()

CMyEQBar::CMyEQBar() : CProgressCtrl()
{
	MemDCCreated = false;
}


/////////////////////////////////////////////////////////////////////////////
// CEqualizerDlg dialog


CEqualizerDlg::CEqualizerDlg() : CDialog(CEqualizerDlg::IDD)
{
}

CEqualizerDlg::~CEqualizerDlg()
{
	EqualizerDlg = NULL;
}

CEqualizerDlg* CEqualizerDlg::getInstance()
{
	if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd != NULL)
		EqualizerDlg->SaveWindowPosAndDestroy();
	if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd == NULL)
	{
		delete EqualizerDlg;
		EqualizerDlg = NULL;
	}
	if (EqualizerDlg == NULL)
	{
		EqualizerDlg = new CEqualizerDlg();
		EqualizerDlg->Create(CEqualizerDlg::IDD);
	}
	else
		EqualizerDlg->SetFocus();
	return EqualizerDlg;
}

IMPLEMENT_MENUXP(CEqualizerDlg, CDialog)

BEGIN_MESSAGE_MAP(CEqualizerDlg, CDialog)
ON_BN_CLICKED(IDC_ENABLE_EQ_CHECKBOX, OnEnableEqCheckbox)
ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
ON_WM_CLOSE()
ON_CBN_SELCHANGE(IDC_COMBO_PRESET, OnSelChangeComboPreset)
ON_BN_CLICKED(IDC_SAVE, OnSave)
ON_BN_CLICKED(IDC_DEL, OnDel)
ON_WM_SYSCOMMAND()
ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEqualizerDlg message handlers

void CEqualizerDlg::DoDataExchange(CDataExchange* pDX)
{
	//    CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SAVE, m_savebutton);
	DDX_Control(pDX, IDC_COMBO_PRESET, m_presetcombo);
	DDX_Control(pDX, IDC_ENABLE_EQ_CHECKBOX, m_EnableEQCheckBox);
	DDX_Control(pDX, IDC_SLIDER10, m_Slider[10]);
	DDX_Control(pDX, IDC_SLIDER9, m_Slider[9]);
	DDX_Control(pDX, IDC_SLIDER8, m_Slider[8]);
	DDX_Control(pDX, IDC_SLIDER7, m_Slider[7]);
	DDX_Control(pDX, IDC_SLIDER6, m_Slider[6]);
	DDX_Control(pDX, IDC_SLIDER5, m_Slider[5]);
	DDX_Control(pDX, IDC_SLIDER4, m_Slider[4]);
	DDX_Control(pDX, IDC_SLIDER3, m_Slider[3]);
	DDX_Control(pDX, IDC_SLIDER2, m_Slider[2]);
	DDX_Control(pDX, IDC_SLIDER1, m_Slider[1]);
	DDX_Control(pDX, IDC_PREAMP, m_Slider[0]);
	DDX_Control(pDX, IDC_DEL, m_btn_Del);
	DDX_Control(pDX, IDC_BUTTON_RESET, m_btn_Reset);
}


void CEqualizerDlg::OnButtonReset()
{
	for (int i = 0; i < 11; i++)
	{
		m_Slider[i].SetPos(10);
	}
	UpdateValues();
	m_presetcombo.SetCurSel(pMainFrame->EQPreset = -1);
}

void CEqualizerDlg::OnCancel()
{
	SaveWindowPosAndDestroy();
}

void CEqualizerDlg::OnClose()
{
	SaveWindowPosAndDestroy();
}

void CEqualizerDlg::OnDel()
{
	if (m_presetcombo.GetCurSel() == CB_ERR)
		return;
	pMainFrame->EQPreset = m_presetcombo.GetCurSel();
	CString buf;
	m_presetcombo.GetLBText(pMainFrame->EQPreset, buf);
	for (int i = 0; i < pMainFrame->presets.GetSize(); i++)
	{
		if (buf == pMainFrame->presets[i].Left(pMainFrame->presets[i].Find('\t')))
		{
			pMainFrame->presets.RemoveAt(i);
			break;
		}
	}
	m_presetcombo.DeleteString(pMainFrame->EQPreset);
	m_presetcombo.SetCurSel(pMainFrame->EQPreset = -1);
}

void CEqualizerDlg::OnEnableEqCheckbox()
{
	UpdateValues();
}

BOOL CEqualizerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_Helper.translateWindowText(this, IDD_EQUALIZER_DIALOG);
	m_Helper.translateDlgItemText(this, IDC_ENABLE_EQ_CHECKBOX);
	m_Helper.translateDlgItemText(this, IDC_BUTTON_RESET);
	m_Helper.translateDlgItemText(this, IDC_LPREAMP);
	m_Helper.translateDlgItemText(this, IDC_LPRESET);
	m_Helper.translateDlgItemText(this, IDC_SAVE);
	m_Helper.translateDlgItemText(this, IDC_DEL);

	SetIcon(pMainFrame->StpIcon, TRUE);
	SetIcon(pMainFrame->StpIconSm, FALSE);

	CRect rect1, rect2;


	::SystemParametersInfo(SPI_GETWORKAREA, 0, &rect1, 0);
	GetWindowRect(&rect2);
	if (pMainFrame->EqualizerX == -1000)
		pMainFrame->EqualizerX = (rect1.right - (rect2.right - rect2.left)) / 2;
	if (pMainFrame->EqualizerY == -1000)
		pMainFrame->EqualizerY = (rect1.bottom - (rect2.bottom - rect2.top)) / 2;
	if (pMainFrame->EqualizerX < 0)
		pMainFrame->EqualizerX = 0;
	if (pMainFrame->EqualizerY < 0)
		pMainFrame->EqualizerY = 0;
	if (pMainFrame->EqualizerX + (rect2.right - rect2.left) > rect1.right)
		pMainFrame->EqualizerX = rect1.right - (rect2.right - rect2.left);
	if (pMainFrame->EqualizerY + (rect2.bottom - rect2.top) > rect1.bottom)
		pMainFrame->EqualizerY = rect1.bottom - (rect2.bottom - rect2.top);
	SetWindowPos(NULL, pMainFrame->EqualizerX, pMainFrame->EqualizerY, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, 9999, m_Helper.MyLoadString(IDS_ALWAYSONTOP));
	}
	if (pMainFrame->EQOnTop == 1)
	{
		pSysMenu->CheckMenuItem(9999, MF_BYCOMMAND | MF_CHECKED);
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
	}
	else
		ModifyStyleEx(0, WS_EX_APPWINDOW);

	m_EnableEQCheckBox.SetCheck(pMainFrame->m_EEQ);
	// set the range for the sliders
	// set the initial position for the sliders
	for (int i = 0; i < 11; i++)
	{
		m_Slider[i].SetRange(0, 20);
		m_Slider[i].SetPos(pMainFrame->m_s[i] + 10);
	}

	for (int i = 0; i < pMainFrame->presets.GetSize(); i++)
		m_presetcombo.AddString(pMainFrame->presets[i].Left(pMainFrame->presets[i].Find('\t')));

	m_presetcombo.SetCurSel(pMainFrame->EQPreset);

	OnSelChangeComboPreset();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CEqualizerDlg::OnSave()
{
	CPrName dlg;
	if (dlg.DoModal() == IDOK)
	{
		for (int i = 0; i < pMainFrame->presets.GetSize(); i++)
		{
			if (dlg.m_prname == pMainFrame->presets[i].Left(pMainFrame->presets[i].Find('\t')))
			{
				pMainFrame->presets[i] = dlg.m_prname + "\t";
				for (int j = 0; j < 11; j++)
				{
					pMainFrame->presets[i] = pMainFrame->presets[i] + ((char)(m_Slider[j].GetPos() + 'a'));
				}
				m_presetcombo.SetCurSel(pMainFrame->EQPreset = m_presetcombo.FindStringExact(-1, dlg.m_prname));
				return;
			}
		}
		CString buf = dlg.m_prname + "\t";
		for (int i = 0; i < 11; i++)
		{
			buf = buf + ((char)(m_Slider[i].GetPos() + 'a'));
		}
		pMainFrame->presets.Add(buf);
		m_presetcombo.AddString(dlg.m_prname);
		m_presetcombo.SetCurSel(pMainFrame->EQPreset = m_presetcombo.FindStringExact(-1, dlg.m_prname));
		return;
	}
}

void CEqualizerDlg::OnSelChangeComboPreset()
{
	if (m_presetcombo.GetCurSel() == CB_ERR)
		return;
	pMainFrame->EQPreset = m_presetcombo.GetCurSel();
	CString buf;
	m_presetcombo.GetLBText(pMainFrame->EQPreset, buf);
	for (int i = 0; i < pMainFrame->presets.GetSize(); i++)
	{
		if (buf == pMainFrame->presets[i].Left(pMainFrame->presets[i].Find('\t')))
		{
			buf = pMainFrame->presets[i].Mid(pMainFrame->presets[i].Find('\t') + 1);
			break;
		}
	}

	for (int i = 0; i < 11; i++)
	{
		m_Slider[i].SetPos((int)buf[i] - 'a');
	}

	UpdateValues();
}

void CEqualizerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID == 9999)
	{
		if (pMainFrame->EQOnTop == 1)
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999, MF_BYCOMMAND | MF_UNCHECKED);

			ShowWindow(SW_HIDE);
			ModifyStyleEx(0, WS_EX_APPWINDOW);
			ShowWindow(SW_SHOW);

			SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
			pMainFrame->EQOnTop = 0;
		}
		else
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999, MF_BYCOMMAND | MF_CHECKED);

			ShowWindow(SW_HIDE);
			ModifyStyleEx(WS_EX_APPWINDOW, 0);
			ShowWindow(SW_SHOW);

			SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
			pMainFrame->EQOnTop = 1;
		}
	}
	else
		CDialog::OnSysCommand(nID, lParam);
}


void CEqualizerDlg::SaveWindowPosAndDestroy()
{
	ShowWindow(SW_RESTORE);
	CRect rect;
	GetWindowRect(&rect);
	pMainFrame->EqualizerX = rect.left;
	pMainFrame->EqualizerY = rect.top;

	DestroyWindow();
}

void CEqualizerDlg::UpdateValues()
{
	double eq[32];

	pMainFrame->m_EEQ = m_EnableEQCheckBox.GetCheck();

	for (int i = 0; i < 11; i++)
	{
		pMainFrame->m_s[i] = m_Slider[i].GetPos() - 10;
	}

	if (m_EnableEQCheckBox.GetCheck() == FALSE)
	{
		// TODO unset the equalizer
		return;
	}
	// TODO

	// compute channel bands;

	eq[0] = pMainFrame->m_s[1];
	eq[1] = pMainFrame->m_s[2];
	eq[2] = pMainFrame->m_s[3];
	eq[3] = pMainFrame->m_s[4];
	eq[4] = pMainFrame->m_s[5];
	eq[5] = pMainFrame->m_s[6];
	eq[6] = pMainFrame->m_s[7];
	eq[7] = pMainFrame->m_s[7];
	eq[8] = pMainFrame->m_s[8];
	eq[9] = pMainFrame->m_s[8];
	eq[10] = pMainFrame->m_s[8];
	eq[11] = pMainFrame->m_s[8];
	eq[12] = pMainFrame->m_s[9];
	eq[13] = pMainFrame->m_s[9];
	eq[14] = pMainFrame->m_s[9];
	eq[15] = pMainFrame->m_s[9];
	eq[16] = pMainFrame->m_s[9];
	eq[17] = pMainFrame->m_s[9];
	eq[18] = pMainFrame->m_s[9];
	eq[19] = pMainFrame->m_s[9];
	eq[20] = pMainFrame->m_s[10];
	eq[21] = pMainFrame->m_s[10];
	eq[22] = pMainFrame->m_s[10];
	eq[23] = pMainFrame->m_s[10];
	eq[24] = pMainFrame->m_s[10];
	eq[25] = pMainFrame->m_s[10];
	eq[26] = pMainFrame->m_s[10];
	eq[27] = pMainFrame->m_s[10];
	eq[28] = pMainFrame->m_s[10];
	eq[29] = pMainFrame->m_s[10];
	eq[30] = pMainFrame->m_s[10];
	eq[31] = pMainFrame->m_s[10];

	//TODO
}

void CMyEQBar::OnLButtonDown(UINT nFlags, CPoint point)
{
	CRect rect;
	GetClientRect(&rect);
	SetPos((int)(((float)(rect.Height()) - (float)point.y + (float)rect.Height() / (float)40) * (float)20 / (float)(rect.Height())));
	EqualizerDlg->UpdateValues();
	EqualizerDlg->m_presetcombo.SetCurSel(pMainFrame->EQPreset = -1);
}

void CMyEQBar::OnMouseMove(UINT nFlags, CPoint point)
{
	if (nFlags & MK_LBUTTON)
	{
		CRect rect;
		GetClientRect(&rect);
		SetPos((int)(((float)(rect.Height()) - (float)point.y + (float)rect.Height() / (float)40) * (float)20 / (float)(rect.Height())));
		EqualizerDlg->UpdateValues();
		EqualizerDlg->m_presetcombo.SetCurSel(pMainFrame->EQPreset = -1);
	}
}

void CMyEQBar::OnPaint()
{
	CPaintDC dc(this);

	if (!MemDCCreated)
	{
		memDC.CreateCompatibleDC(&dc);
		CRect rect;
		GetClientRect(&rect);
		memBitmap.CreateCompatibleBitmap(&dc, width = rect.Width(), height = rect.Height());
		memDC.SelectObject(&memBitmap);

		MemDCCreated = true;
	}

	memDC.FillSolidRect(0, 0, width, height, ::GetSysColor(COLOR_BTNFACE));

	DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);

	CPen * p_pen, pen1(PS_SOLID, 0, ::GetSysColor(COLOR_BTNFACE)), pen2(PS_SOLID, 0, ::GetSysColor(COLOR_HIGHLIGHT));
	p_pen = memDC.SelectObject(&pen1);
	bool flag = true;
	for (int i = 1; i < 20; i++)
	{
		if (flag && i > GetPos())
		{
			flag = false;
			memDC.SelectObject(&pen2);
		}
		memDC.MoveTo(i == 10 ? 1 : width / 3, height - height * i / 20);
		memDC.LineTo(width - (i == 10 ? 1 : width / 3), height - height * i / 20);
	}

	memDC.SelectObject(p_pen);

	dc.BitBlt(0, 0, width, height, &memDC, 0, 0, SRCCOPY);
}

