#ifndef SEEKDIALOG_H
#define SEEKDIALOG_H

class CTranspBmp : public CStatic
{
	// Construction
public:
	CTranspBmp();

	HBITMAP bmp;
	int w;
	int h;
	//inversion de gradient
	bool inverse;

	void Create(WORD idb, int width, int height);
	void Delete();

	afx_msg void OnPaint();
	DECLARE_MESSAGE_MAP()
};

class CMyPrBar : public CProgressCtrl
{
	// Construction
public:
	CMyPrBar();
	CDC memDC;
	CBitmap memBitmap;
	bool MemDCCreated;
	int width;
	int height;

	afx_msg void OnPaint();
protected:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	DECLARE_MESSAGE_MAP()
};

class CMyPrBarVol : public CProgressCtrl
{
	// Construction
public:
	CMyPrBarVol();

	bool ScrollFlag;
	CDC memDC;
	CBitmap memBitmap;
	bool MemDCCreated;
	int width;
	int height;
	afx_msg void OnPaint();

protected:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CSeekDialog dialog

class CSeekDialog : public CDialog
{
	// Construction
public:
	CSeekDialog();   // standard constructor
	~CSeekDialog();
	CSeekDialog* getInstance();
	void DrawGradient(CDC* pDC, COLORREF clrStart, COLORREF clrEnd, LPCRECT pRect);
	void OnNext();
	void OnPause();
	void OnPlay();
	void OnPrev();
	void OnStop();
	void SaveWindowPosAndDestroy();

	bool CanResize;
	int w1;
	int w2;
	int l1;
	int h1;
	CString CurrentTime;
	CString CurrentSong;
	bool HDocked;
	bool VDocked;
	BOOL ScrollFlag;

	CMyPrBar m_bar;
	CMyPrBarVol m_vol;
	CTranspBmp m_ipe;
	CTranspBmp m_mb;

	enum {
		IDD = IDD_SEEK
	};

	// Overrides
protected:
	virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV support

	// Implementation
protected:
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMoving(UINT nSide, LPRECT lpRect);
	afx_msg void OnPaint();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSizing(UINT nSide, LPRECT lpRect);
	afx_msg void OnTimer(UINT nIDEvent);
	DECLARE_MESSAGE_MAP()
};

#endif

extern CSeekDialog* SeekDialog;