#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H
#include "Tools/ButtonXP.h"
#include "Tools/MenuXP.h"
#include "SettingsDialogGeneral.h"
#include "SettingsDialogHotkeys.h"
#include "SettingsDialogW2File.h"
#include "SettingsDialogMouseClicks.h"
#include "SettingsDialogApparence.h"
#include "SettingsDialogApparenceSkins.h"
#include "SettingsDialogApparenceTooltip.h"
#include "SettingsDialogInput.h"
#include "SettingsDialogOutput.h"
#include "SettingsDialogGen.h"
#include "TreePropSheet/TreePropSheet.h"
#include "wa_ipc.h"

/////////////////////////////////////////////////////////////////////////////
// CSettingsDialog dialog

class CSettingsDialog : public CDialog
{
	DECLARE_DYNAMIC(CSettingsDialog)
	// Construction
public:
	CSettingsDialog();   // standard constructor
	CSettingsDialog* getInstance();
	~CSettingsDialog();
	virtual BOOL DestroyWindow();

	enum
	{
		IDD = IDD_SETTINGS
	};

	CButtonXP m_BtnOk;
	CButtonXP m_BtnCancel;

	TreePropSheet::CTreePropSheet m_TabSetting;
	CPtrArray listPropertyPage;
	CSettingsDialogGeneral m_SettingsDialogGeneral;
	CSettingsDialogHotkeys m_SettingsDialogHotkeys;
	CSettingsDialogW2File m_SettingsDialogW2File;
	CSettingsDialogMouseClicks m_SettingsDialogMouseClicks;
	CSettingsDialogInput m_SettingsDialogInput;
	CSettingsDialogOutput m_SettingsDialogOutput;
	CSettingsDialogGen m_SettingsDialogGen;
	CSettingsDialogApparence m_SettingsDialogApparence;
	CSettingsDialogApparenceTooltip m_SettingsDialogApparenceTooltip;
	CSettingsDialogApparenceSkins m_SettingsDialogApparenceSkins;
	void SetActivePage(int index);
	void SetActivePage(prefsDlgRec* iPrefs);
	CPPToolTip* m_tooltip;
	CString toolTipText;

	int CurrentSkinSel;
	SkinStruct loadSkin;
	void DisplaySkin(CWnd* pSkinSampleWnd, int frg = -1, int forceText = -1);
	void DisplayImage(HDC hdc, HDC hdc1, HBITMAP image, CRect rect, int frg = -1);
	void DisplayText(HDC hdc, HDC hdc5, HBITMAP bm5, CRect rect, int frg = -1, int forceText = -1);

	// Overrides
protected:
	virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV support
	// Implementation
protected:
	afx_msg void OnCreate(LPCREATESTRUCT lpCreateStruct);
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	DECLARE_MESSAGE_MAP()
		DECLARE_MENUXP()
};
#endif

extern CSettingsDialog* SettingsDialog;