//WAEmuWnd.cpp : implementation file
//

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "resource.h"
#include "MainWnd.h"
#include "AboutDlg.h"
#include "WAEmuWnd.h"
#include "Volume.h"
#include "out/MultiDllOutput.h"
#include "In/MultiDllInput.h"
#include "SeekDialog.h"
#include "wa_ipc.h"
#include "EqualizerDlg.h"
#include "PlaylistDlg.h"
#include "PlaylistManager.h"
#include "convert.h"
#include "zlib/zlib.h"
#include "SettingsDialog.h"
#include "ipc_pe.h"
#include "tagz.h"
#include <math.h>
#include "Tools/filters.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

UINT registerID[10] =
{
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

prefsDlgRec* prefs;
extern CPtrArray listPrefs;
extern int infoBitrate;
extern int infoSamplerate;
extern int infoStereo; 
extern int infoSynched;
int infoWidth;
int infoHeight;
CString infoTitle;

BEGIN_MESSAGE_MAP(CVidOut, CDialog)
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	ON_WM_PAINT()
END_MESSAGE_MAP()

CVidOut::CVidOut() : CDialog(CVidOut::IDD)
{
	donnees = NULL;
	m_bmpinfo = NULL;
	CanResize = false;
	width = 10;
	height = 10;
}
CVidOut::~CVidOut()
{
	if (m_bmpinfo != NULL)
	{
		delete m_bmpinfo;
		m_bmpinfo = NULL;
	}
	if (this->m_hWnd != NULL)
		this->DestroyWindow();
	if (donnees != NULL)
	{
		delete donnees;
		donnees = NULL;
	}
}

void CVidOut::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CVidOut::OnInitDialog()
{
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVidOut::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);
	CanResize = bShow ? true : false;
}
void CVidOut::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	if (CanResize)
	{
		CRect rectangle;
		GetWindowRect(&rectangle);
		/*		if(rectangle.Width()>width)
										rectangle.right = rectangle.left + width;
									if(rectangle.Height()>height)
										rectangle.bottom = rectangle.top + height;
							*/		this->SetWindowPos(NULL, 0, 0, rectangle.Width(), rectangle.Height(), SWP_NOMOVE | SWP_NOZORDER);
		Draw();
	}
}

void CVidOut::OnPaint()
{
	CDialog::OnPaint();
	CDC* dc = GetDC();

	CRect rectangle, rectangle1, rectangle2;
	GetClientRect(&rectangle);
	ClientToScreen(&rectangle);

	rectangle1.top = rectangle.top;
	rectangle1.left = rectangle.left;
	rectangle1.bottom = rectangle.top + rectangle.Height();
	rectangle1.right = rectangle.left + rectangle.Height() * width / height;

	rectangle2.top = rectangle.top;
	rectangle2.left = rectangle.left;
	rectangle2.bottom = rectangle.top + rectangle.Width() * height / width;
	rectangle2.right = rectangle.left + rectangle.Width();

	COLORREF cColor = RGB(0, 0, 0);
	if (rectangle1.Width() < rectangle.Width())
	{
		rectangle1.OffsetRect((rectangle.Width() - rectangle1.Width()) / 2, 0);
		CRect noirGauche, noirDroite;
		noirGauche.top = rectangle.top;
		noirGauche.bottom = rectangle.bottom;
		noirGauche.left = rectangle.left;
		noirGauche.right = rectangle1.left;
		ScreenToClient(&noirGauche);
		dc->FillSolidRect(noirGauche.left, noirGauche.top, noirGauche.Width(), noirGauche.Height(), cColor);

		noirDroite.top = rectangle.top;
		noirDroite.bottom = rectangle.bottom;
		noirDroite.left = rectangle1.right;
		noirDroite.right = rectangle.right;
		ScreenToClient(&noirDroite);
		dc->FillSolidRect(noirDroite.left, noirDroite.top, noirDroite.Width(), noirDroite.Height(), cColor);
	}
	else
	{
		rectangle2.OffsetRect(0, (rectangle.Height() - rectangle2.Height()) / 2);
		CRect noirGauche, noirDroite;
		noirGauche.top = rectangle.top;
		noirGauche.bottom = rectangle2.top;
		noirGauche.left = rectangle.left;
		noirGauche.right = rectangle.right;
		ScreenToClient(&noirGauche);
		dc->FillSolidRect(noirGauche.left, noirGauche.top, noirGauche.Width(), noirGauche.Height(), cColor);

		noirDroite.top = rectangle2.bottom;
		noirDroite.bottom = rectangle.bottom;
		noirDroite.left = rectangle.left;
		noirDroite.right = rectangle.right;
		ScreenToClient(&noirDroite);
		dc->FillSolidRect(noirDroite.left, noirDroite.top, noirDroite.Width(), noirDroite.Height(), cColor);
	}
	Draw();
}

__forceinline void CVidOut::Draw()
{
	if (width > 10)
	{
		CRect rectangle, rectangle1, rectangle2;
		GetClientRect(&rectangle);
		ClientToScreen(&rectangle);

		rectangle1.top = rectangle.top;
		rectangle1.left = rectangle.left;
		rectangle1.bottom = rectangle.top + rectangle.Height();
		rectangle1.right = rectangle.left + rectangle.Height() * width / height;

		rectangle2.top = rectangle.top;
		rectangle2.left = rectangle.left;
		rectangle2.bottom = rectangle.top + rectangle.Width() * height / width;
		rectangle2.right = rectangle.left + rectangle.Width();
		if (rectangle1.Width() < rectangle.Width())
		{
			rectangle1.OffsetRect((rectangle.Width() - rectangle1.Width()) / 2, 0);
			ScreenToClient(&rectangle1);
			SetStretchBltMode(this->GetDC()->m_hDC, HALFTONE);
			StretchDIBits(this->GetDC()->m_hDC, rectangle1.left, rectangle1.top, rectangle1.Width(), rectangle1.Height(), 0, 0, width, height,
						  donnees, (LPBITMAPINFO)&m_bmpinfo->bmiHeader, DIB_RGB_COLORS, SRCCOPY);
		}
		else
		{
			rectangle2.OffsetRect(0, (rectangle.Height() - rectangle2.Height()) / 2);

			ScreenToClient(&rectangle2);
			SetStretchBltMode(this->GetDC()->m_hDC, HALFTONE);
			StretchDIBits(this->GetDC()->m_hDC, rectangle2.left, rectangle2.top, rectangle2.Width(), rectangle2.Height(), 0, 0, width, height,
						  donnees, (LPBITMAPINFO)&m_bmpinfo->bmiHeader, DIB_RGB_COLORS, SRCCOPY);
		}
	}
}

CIVideoOutput::CIVideoOutput()
{
	InitConvertTable();

	RGB_Scale = 0x1000254310002543;
	RGB_Offset = 0x0010001000100010;
	RGB_CBU = 0x0000428500004285;
	RGB_CGX = 0xF7BFEEA3F7BFEEA3;
	RGB_CRV = 0x0000396900003969;
	InitializeFilter();
}
CIVideoOutput::~CIVideoOutput()
{
}

void CIVideoOutput::SetVidOut(CVidOut* pvidOut)
{
	vidOut = pvidOut;
}

int CIVideoOutput::open(int w, int h, int vflip, double aspectratio, unsigned int fmt)
{
	char ch[5];
	ch[0] = (char)(fmt & 0xFF);
	ch[1] = (char)(fmt >> 8 & 0xFF);
	ch[2] = (char)(fmt >> 16 & 0xFF);
	ch[3] = (char)(fmt >> 24 & 0xFF);
	ch[4] = 0;
	TRACE(_T("open %d %d %d %f %d %s\n"), w, h, vflip, aspectratio, fmt, ch);
	width = w;
	height = h;
	vidOut->width = w;
	vidOut->height = h;
	infoWidth = w;
	infoHeight = h;

	Coded_Picture_Width = w;
	Coded_Picture_Height = h;

	Clip_Width = w;
	Clip_Height = h;

	CLIP_AREA = HALF_CLIP_AREA = CLIP_STEP = CLIP_HALF_STEP = 0;

	NINE_CLIP_WIDTH = Clip_Width * 9;
	QUAD_CLIP_WIDTH = Clip_Width << 2;
	DOUBLE_CLIP_WIDTH = Clip_Width << 1;
	HALF_CLIP_WIDTH = Clip_Width >> 1;

	LUM_AREA = Coded_Picture_Width * Clip_Height;
	DOUBLE_WIDTH = Coded_Picture_Width << 1;
	HALF_WIDTH = Coded_Picture_Width >> 1;
	HALF_WIDTH_D8 = (Coded_Picture_Width >> 1) - 8;
	PROGRESSIVE_HEIGHT = (Coded_Picture_Height >> 1) - 2;
	INTERLACED_HEIGHT = (Coded_Picture_Height >> 2) - 2;
	RGB_DOWN1 = Clip_Width * (Clip_Height - 1) * 3;
	RGB_DOWN2 = Clip_Width * (Clip_Height - 2) * 3;


	if (vidOut->m_bmpinfo != NULL)
	{
		delete vidOut->m_bmpinfo;
		vidOut->m_bmpinfo = NULL;
	}
	vidOut->m_bmpinfo = new BITMAPINFO;
	vidOut->m_bmpinfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	vidOut->m_bmpinfo->bmiHeader.biWidth = width;
	vidOut->m_bmpinfo->bmiHeader.biHeight = height;
	vidOut->m_bmpinfo->bmiHeader.biPlanes = 1;
	vidOut->m_bmpinfo->bmiHeader.biBitCount = 24;
	vidOut->m_bmpinfo->bmiHeader.biCompression = BI_RGB;
	vidOut->m_bmpinfo->bmiHeader.biSizeImage = 0;
	vidOut->m_bmpinfo->bmiHeader.biXPelsPerMeter = 0;
	vidOut->m_bmpinfo->bmiHeader.biYPelsPerMeter = 0;
	vidOut->m_bmpinfo->bmiHeader.biClrUsed = 0;
	vidOut->m_bmpinfo->bmiHeader.biClrImportant = 0;

	if (vidOut->donnees != NULL)
	{
		delete vidOut->donnees;
		vidOut->donnees = NULL;
	}
	vidOut->donnees = (unsigned char*)calloc(3 * width * height, sizeof(unsigned char*));

	return 0;
}
void CIVideoOutput::setcallback(LRESULT(*msgcallback)(void* token, HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam), void* token)
{
	TRACE(_T("setcallback\n"));
}

void CIVideoOutput::close()
{
	TRACE(_T("close\n"));
}

void CIVideoOutput::draw(void* frame)
{
	//	TRACE(_T("draw\n"));
	BYTE* pdon;
	YV12_PLANES* fr = (YV12_PLANES*)frame;
	pdon = vidOut->donnees;

	//ConvertYUV4202RGB(fr->y.baseAddr, fr->u.baseAddr, fr->v.baseAddr, pdon, width, height);

	unsigned char* uu, * vv, * uu2, * vv2;
	uu = new unsigned char[width * height];
	vv = new unsigned char[width * height];
	uu2 = new unsigned char[width * height];
	vv2 = new unsigned char[width * height];

	conv420to422(fr->u.baseAddr, uu, true);
	conv420to422(fr->v.baseAddr, vv, true);
	conv422to444(uu, uu2);
	conv422to444(vv, vv2);
	conv444toRGB24odd(fr->y.baseAddr, uu2, vv2, pdon);
	conv444toRGB24even(fr->y.baseAddr, uu2, vv2, pdon);

	//	ConvertYUV4202YUV422(fr->u.baseAddr, fr->v.baseAddr, uu, vv, width, height);
	//	ConvertYUV4222YUV444(uu, vv, uu2, vv2, width, height);
	//	ConvertYUV4442RGB(fr->y.baseAddr, uu2, vv2, pdon, width, height);

	delete uu;
	delete vv;
	delete uu2;
	delete vv2;
	vidOut->Draw();
}

void CIVideoOutput::drawSubtitle(SubsItem* item)
{
	TRACE(_T("drawSubtitle\n"));
}

void CIVideoOutput::showStatusMsg(const char* text)
{
	TRACE(_T("showStatusMsg %s\n"), text);
}

int CIVideoOutput::get_latency()
{
	TRACE(_T("get_latency\n"));
	return 0;
}

void CIVideoOutput::notifyBufferState(int bufferstate)
{
	TRACE(_T("notifyBufferState %d\n"), bufferstate);
} /* 0-255*/

int CIVideoOutput::extended(int param1, int param2, int param3)
{
	switch (param1)
	{
	case VIDUSER_SET_INFOSTRING:
		TRACE(_T("extended VIDUSER_SET_INFOSTRING %s %d\n"), (char*)param2, param3);
		infoTitle.Format(_T("%s"), (char*)param2);
		break;
	case VIDUSER_GET_VIDEOHWND:
		TRACE(_T("extended VIDUSER_GET_VIDEOHWND %d %d\n"), param2, param3);
		break;
	case VIDUSER_SET_VFLIP:
		TRACE(_T("extended VIDUSER_SET_VFLIP %d %d\n"), param2, param3);
		break;
	case VIDUSER_SET_TRACKSELINTERFACE:
		TRACE(_T("extended VIDUSER_SET_TRACKSELINTERFACE %d %d\n"), param2, param3);
		break;
	}
	return 0;
} //Dispatchable, eat this!

/////////////////////////////////////////////////////////////////////////////
//CWAEmuWnd

IMPLEMENT_DYNCREATE(CWAEmuWnd, CFrameWnd)

/////////////////////////////////////////////////////////////////////////////
//CWAEmuWnd message handlers
CWAEmuWnd::CWAEmuWnd()
{
	vidOut = new CVidOut();
	vidOut->Create(CVidOut::IDD);
	iVidOut = new CIVideoOutput();
	iVidOut->SetVidOut(vidOut);
}

CWAEmuWnd::~CWAEmuWnd()
{
	delete vidOut;
	vidOut = NULL;
	delete iVidOut;
	iVidOut = NULL;
	WAEmuWnd = NULL;
}

BOOL CWAEmuWnd::DestroyWindow()
{
	pMainFrame->OnPopupMenuExit();
	pMainFrame->Created = false;
	return CFrameWnd::DestroyWindow();
}

CWAEmuWnd* CWAEmuWnd::getInstance()
{
	if (WAEmuWnd != NULL && WAEmuWnd->m_hWnd != NULL)
		WAEmuWnd->DestroyWindow();
	if (WAEmuWnd != NULL && WAEmuWnd->m_hWnd == NULL)
	{
		delete WAEmuWnd;
		WAEmuWnd = NULL;
	}
	if (WAEmuWnd == NULL)
	{
		WAEmuWnd = new CWAEmuWnd();
		WAEmuWnd->Create(_T("Winamp v1.x"), _T("Winamp"));
	}
	else
		WAEmuWnd->SetFocus();
	return WAEmuWnd;
}
BEGIN_MESSAGE_MAP(CWAEmuWnd, CFrameWnd)
	ON_COMMAND(WINAMP_FILE_QUIT, OnMessageWINAMP_FILE_QUIT)
	ON_COMMAND(WINAMP_OPTIONS_PREFS, OnMessageWINAMP_OPTIONS_PREFS)
	ON_COMMAND(WINAMP_OPTIONS_AOT, OnMessageWINAMP_OPTIONS_AOT)
	ON_COMMAND(WINAMP_FILE_REPEAT, OnMessageWINAMP_FILE_REPEAT)
	ON_COMMAND(WINAMP_FILE_SHUFFLE, OnMessageWINAMP_FILE_SHUFFLE)
	ON_COMMAND(WINAMP_HIGH_PRIORITY, OnMessageWINAMP_HIGH_PRIORITY)
	ON_COMMAND(WINAMP_FILE_PLAY, OnMessageWINAMP_FILE_PLAY)
	ON_COMMAND(WINAMP_OPTIONS_EQ, OnMessageWINAMP_OPTIONS_EQ)
	ON_COMMAND(WINAMP_OPTIONS_ELAPSED, OnMessageWINAMP_OPTIONS_ELAPSED)
	ON_COMMAND(WINAMP_OPTIONS_REMAINING, OnMessageWINAMP_OPTIONS_REMAINING)
	ON_COMMAND(WINAMP_OPTIONS_PLEDIT, OnMessageWINAMP_OPTIONS_PLEDIT)
	ON_COMMAND(WINAMP_HELP_ABOUT, OnMessageWINAMP_HELP_ABOUT)
	ON_COMMAND(WINAMP_MAINMENU, OnMessageWINAMP_MAINMENU)
	ON_COMMAND(WINAMP_BUTTON1, OnMessageWINAMP_BUTTON1)
	ON_COMMAND(WINAMP_BUTTON2, OnMessageWINAMP_BUTTON2)
	ON_COMMAND(WINAMP_BUTTON3, OnMessageWINAMP_BUTTON3)
	ON_COMMAND(WINAMP_BUTTON4, OnMessageWINAMP_BUTTON4)
	ON_COMMAND(WINAMP_BUTTON5, OnMessageWINAMP_BUTTON5)
	ON_COMMAND(WINAMP_BUTTON1_SHIFT, OnMessageWINAMP_BUTTON1_SHIFT)
	ON_COMMAND(WINAMP_BUTTON2_SHIFT, OnMessageWINAMP_BUTTON2_SHIFT)
	ON_COMMAND(WINAMP_BUTTON3_SHIFT, OnMessageWINAMP_BUTTON3_SHIFT)
	ON_COMMAND(WINAMP_BUTTON4_SHIFT, OnMessageWINAMP_BUTTON4_SHIFT)
	ON_COMMAND(WINAMP_BUTTON5_SHIFT, OnMessageWINAMP_BUTTON5_SHIFT)
	ON_COMMAND(WINAMP_BUTTON1_CTRL, OnMessageWINAMP_BUTTON1_CTRL)
	ON_COMMAND(WINAMP_BUTTON2_CTRL, OnMessageWINAMP_BUTTON2_CTRL)
	ON_COMMAND(WINAMP_BUTTON3_CTRL, OnMessageWINAMP_BUTTON3_CTRL)
	ON_COMMAND(WINAMP_BUTTON4_CTRL, OnMessageWINAMP_BUTTON4_CTRL)
	ON_COMMAND(WINAMP_BUTTON5_CTRL, OnMessageWINAMP_BUTTON5_CTRL)
	ON_COMMAND(WINAMP_VOLUMEUP, OnMessageWINAMP_VOLUMEUP)
	ON_COMMAND(WINAMP_VOLUMEDOWN, OnMessageWINAMP_VOLUMEDOWN)
	ON_COMMAND(WINAMP_FFWD5S, OnMessageWINAMP_FFWD5S)
	ON_COMMAND(WINAMP_REW5S, OnMessageWINAMP_REW5S)
	ON_COMMAND(WINAMP_NEXT_WINDOW, OnMessageWINAMP_NEXT_WINDOW)
	ON_COMMAND(WINAMP_OPTIONS_WINDOWSHADE, OnMessageWINAMP_OPTIONS_WINDOWSHADE)
	ON_COMMAND(WINAMP_OPTIONS_DSIZE, OnMessageWINAMP_OPTIONS_DSIZE)
	ON_COMMAND(IDC_SORT_FILENAME, OnMessageIDC_SORT_FILENAME)
	ON_COMMAND(IDC_SORT_FILETITLE, OnMessageIDC_SORT_FILETITLE)
	ON_COMMAND(IDC_SORT_ENTIREFILENAME, OnMessageIDC_SORT_ENTIREFILENAME)
	ON_COMMAND(IDC_SELECTALL, OnMessageIDC_SELECTALL)
	ON_COMMAND(IDC_SELECTNONE, OnMessageIDC_SELECTNONE)
	ON_COMMAND(IDC_SELECTINV, OnMessageIDC_SELECTINV)
	ON_COMMAND(IDM_EQ_LOADPRE, OnMessageIDM_EQ_LOADPRE)
	ON_COMMAND(IDM_EQ_LOADMP3, OnMessageIDM_EQ_LOADMP3)
	ON_COMMAND(IDM_EQ_LOADDEFAULT, OnMessageIDM_EQ_LOADDEFAULT)
	ON_COMMAND(IDM_EQ_SAVEPRE, OnMessageIDM_EQ_SAVEPRE)
	ON_COMMAND(IDM_EQ_SAVEMP3, OnMessageIDM_EQ_SAVEMP3)
	ON_COMMAND(IDM_EQ_SAVEDEFAULT, OnMessageIDM_EQ_SAVEDEFAULT)
	ON_COMMAND(IDM_EQ_DELPRE, OnMessageIDM_EQ_DELPRE)
	ON_COMMAND(IDM_EQ_DELMP3, OnMessageIDM_EQ_DELMP3)
	ON_COMMAND(IDC_PLAYLIST_PLAY, OnMessageIDC_PLAYLIST_PLAY)
	ON_COMMAND(WINAMP_FILE_LOC, OnMessageWINAMP_FILE_LOC)
	ON_COMMAND(WINAMP_OPTIONS_EASYMOVE, OnMessageWINAMP_OPTIONS_EASYMOVE)
	ON_COMMAND(WINAMP_FILE_DIR, OnMessageWINAMP_FILE_DIR)
	ON_COMMAND(WINAMP_EDIT_ID3, OnMessageWINAMP_EDIT_ID3)
	ON_COMMAND(WINAMP_TOGGLE_AUTOSCROLL, OnMessageWINAMP_TOGGLE_AUTOSCROLL)
	ON_COMMAND(WINAMP_VISSETUP, OnMessageWINAMP_VISSETUP)
	ON_COMMAND(WINAMP_PLGSETUP, OnMessageWINAMP_PLGSETUP)
	ON_COMMAND(WINAMP_VISPLUGIN, OnMessageWINAMP_VISPLUGIN)
	ON_COMMAND(WINAMP_JUMP, OnMessageWINAMP_JUMP)
	ON_COMMAND(WINAMP_JUMPFILE, OnMessageWINAMP_JUMPFILE)
	ON_COMMAND(WINAMP_JUMP10FWD, OnMessageWINAMP_JUMP10FWD)
	ON_COMMAND(WINAMP_JUMP10BACK, OnMessageWINAMP_JUMP10BACK)
	ON_COMMAND(WINAMP_PREVSONG, OnMessageWINAMP_PREVSONG)
	ON_COMMAND(WINAMP_OPTIONS_EXTRAHQ, OnMessageWINAMP_OPTIONS_EXTRAHQ)
	ON_COMMAND(ID_PE_NEW, OnMessageID_PE_NEW)
	ON_COMMAND(ID_PE_OPEN, OnMessageID_PE_OPEN)
	ON_COMMAND(ID_PE_SAVE, OnMessageID_PE_SAVE)
	ON_COMMAND(ID_PE_SAVEAS, OnMessageID_PE_SAVEAS)
	ON_COMMAND(ID_PE_SELECTALL, OnMessageID_PE_SELECTALL)
	ON_COMMAND(ID_PE_INVERT, OnMessageID_PE_INVERT)
	ON_COMMAND(ID_PE_NONE, OnMessageID_PE_NONE)
	ON_COMMAND(ID_PE_ID3, OnMessageID_PE_ID3)
	ON_COMMAND(ID_PE_S_TITLE, OnMessageID_PE_S_TITLE)
	ON_COMMAND(ID_PE_S_FILENAME, OnMessageID_PE_S_FILENAME)
	ON_COMMAND(ID_PE_S_PATH, OnMessageID_PE_S_PATH)
	ON_COMMAND(ID_PE_S_RANDOM, OnMessageID_PE_S_RANDOM)
	ON_COMMAND(ID_PE_S_REV, OnMessageID_PE_S_REV)
	ON_COMMAND(ID_PE_CLEAR, OnMessageID_PE_CLEAR)
	ON_COMMAND(ID_PE_MOVEUP, OnMessageID_PE_MOVEUP)
	ON_COMMAND(ID_PE_MOVEDOWN, OnMessageID_PE_MOVEDOWN)
	ON_COMMAND(WINAMP_SELSKIN, OnMessageWINAMP_SELSKIN)
	ON_COMMAND(WINAMP_VISCONF, OnMessageWINAMP_VISCONF)
	ON_COMMAND(ID_PE_NONEXIST, OnMessageID_PE_NONEXIST)
	ON_COMMAND(ID_PE_DELETEFROMDISK, OnMessageID_PE_DELETEFROMDISK)
	ON_COMMAND(ID_PE_CLOSE, OnMessageID_PE_CLOSE)
	ON_COMMAND(WINAMP_VIS_SETOSC, OnMessageWINAMP_VIS_SETOSC)
	ON_COMMAND(WINAMP_VIS_SETANA, OnMessageWINAMP_VIS_SETANA)
	ON_COMMAND(WINAMP_VIS_SETOFF, OnMessageWINAMP_VIS_SETOFF)
	ON_COMMAND(WINAMP_VIS_DOTSCOPE, OnMessageWINAMP_VIS_DOTSCOPE)
	ON_COMMAND(WINAMP_VIS_LINESCOPE, OnMessageWINAMP_VIS_LINESCOPE)
	ON_COMMAND(WINAMP_VIS_SOLIDSCOPE, OnMessageWINAMP_VIS_SOLIDSCOPE)
	ON_COMMAND(WINAMP_VIS_NORMANA, OnMessageWINAMP_VIS_NORMANA)
	ON_COMMAND(WINAMP_VIS_FIREANA, OnMessageWINAMP_VIS_FIREANA)
	ON_COMMAND(WINAMP_VIS_LINEANA, OnMessageWINAMP_VIS_LINEANA)
	ON_COMMAND(WINAMP_VIS_NORMVU, OnMessageWINAMP_VIS_NORMVU)
	ON_COMMAND(WINAMP_VIS_SMOOTHVU, OnMessageWINAMP_VIS_SMOOTHVU)
	ON_COMMAND(WINAMP_VIS_FULLREF, OnMessageWINAMP_VIS_FULLREF)
	ON_COMMAND(WINAMP_VIS_FULLREF2, OnMessageWINAMP_VIS_FULLREF2)
	ON_COMMAND(WINAMP_VIS_FULLREF3, OnMessageWINAMP_VIS_FULLREF3)
	ON_COMMAND(WINAMP_VIS_FULLREF4, OnMessageWINAMP_VIS_FULLREF4)
	ON_COMMAND(WINAMP_OPTIONS_TOGTIME, OnMessageWINAMP_OPTIONS_TOGTIME)
	ON_COMMAND(EQ_ENABLE, OnMessageEQ_ENABLE)
	ON_COMMAND(EQ_AUTO, OnMessageEQ_AUTO)
	ON_COMMAND(EQ_PRESETS, OnMessageEQ_PRESETS)
	ON_COMMAND(WINAMP_VIS_FALLOFF0, OnMessageWINAMP_VIS_FALLOFF0)
	ON_COMMAND(WINAMP_VIS_FALLOFF1, OnMessageWINAMP_VIS_FALLOFF1)
	ON_COMMAND(WINAMP_VIS_FALLOFF2, OnMessageWINAMP_VIS_FALLOFF2)
	ON_COMMAND(WINAMP_VIS_FALLOFF3, OnMessageWINAMP_VIS_FALLOFF3)
	ON_COMMAND(WINAMP_VIS_FALLOFF4, OnMessageWINAMP_VIS_FALLOFF4)
	ON_COMMAND(WINAMP_VIS_PEAKS, OnMessageWINAMP_VIS_PEAKS)
	ON_COMMAND(ID_LOAD_EQF, OnMessageID_LOAD_EQF)
	ON_COMMAND(ID_SAVE_EQF, OnMessageID_SAVE_EQF)
	ON_COMMAND(ID_PE_ENTRY, OnMessageID_PE_ENTRY)
	ON_COMMAND(ID_PE_SCROLLUP, OnMessageID_PE_SCROLLUP)
	ON_COMMAND(ID_PE_SCROLLDOWN, OnMessageID_PE_SCROLLDOWN)
	ON_COMMAND(WINAMP_MAIN_WINDOW, OnMessageWINAMP_MAIN_WINDOW)
	ON_COMMAND(WINAMP_VIS_PFALLOFF0, OnMessageWINAMP_VIS_PFALLOFF0)
	ON_COMMAND(WINAMP_VIS_PFALLOFF1, OnMessageWINAMP_VIS_PFALLOFF1)
	ON_COMMAND(WINAMP_VIS_PFALLOFF2, OnMessageWINAMP_VIS_PFALLOFF2)
	ON_COMMAND(WINAMP_VIS_PFALLOFF3, OnMessageWINAMP_VIS_PFALLOFF3)
	ON_COMMAND(WINAMP_VIS_PFALLOFF4, OnMessageWINAMP_VIS_PFALLOFF4)
	ON_COMMAND(ID_PE_TOP, OnMessageID_PE_TOP)
	ON_COMMAND(ID_PE_BOTTOM, OnMessageID_PE_BOTTOM)
	ON_COMMAND(WINAMP_OPTIONS_WINDOWSHADE_PL, OnMessageWINAMP_OPTIONS_WINDOWSHADE_PL)
	ON_COMMAND(EQ_INC1, OnMessageEQ_INC1)
	ON_COMMAND(EQ_INC2, OnMessageEQ_INC2)
	ON_COMMAND(EQ_INC3, OnMessageEQ_INC3)
	ON_COMMAND(EQ_INC4, OnMessageEQ_INC4)
	ON_COMMAND(EQ_INC5, OnMessageEQ_INC5)
	ON_COMMAND(EQ_INC6, OnMessageEQ_INC6)
	ON_COMMAND(EQ_INC7, OnMessageEQ_INC7)
	ON_COMMAND(EQ_INC8, OnMessageEQ_INC8)
	ON_COMMAND(EQ_INC9, OnMessageEQ_INC9)
	ON_COMMAND(EQ_INC10, OnMessageEQ_INC10)
	ON_COMMAND(EQ_INCPRE, OnMessageEQ_INCPRE)
	ON_COMMAND(EQ_DECPRE, OnMessageEQ_DECPRE)
	ON_COMMAND(EQ_DEC1, OnMessageEQ_DEC1)
	ON_COMMAND(EQ_DEC2, OnMessageEQ_DEC2)
	ON_COMMAND(EQ_DEC3, OnMessageEQ_DEC3)
	ON_COMMAND(EQ_DEC4, OnMessageEQ_DEC4)
	ON_COMMAND(EQ_DEC5, OnMessageEQ_DEC5)
	ON_COMMAND(EQ_DEC6, OnMessageEQ_DEC6)
	ON_COMMAND(EQ_DEC7, OnMessageEQ_DEC7)
	ON_COMMAND(EQ_DEC8, OnMessageEQ_DEC8)
	ON_COMMAND(EQ_DEC9, OnMessageEQ_DEC9)
	ON_COMMAND(EQ_DEC10, OnMessageEQ_DEC10)
	ON_COMMAND(ID_PE_SCUP, OnMessageID_PE_SCUP)
	ON_COMMAND(ID_PE_SCDOWN, OnMessageID_PE_SCDOWN)
	ON_COMMAND(WINAMP_REFRESHSKIN, OnMessageWINAMP_REFRESHSKIN)
	ON_COMMAND(ID_PE_PRINT, OnMessageID_PE_PRINT)
	ON_COMMAND(ID_PE_EXTINFO, OnMessageID_PE_EXTINFO)
	ON_COMMAND(WINAMP_PLAYLIST_ADVANCE, OnMessageWINAMP_PLAYLIST_ADVANCE)
	ON_COMMAND(WINAMP_VIS_LIN, OnMessageWINAMP_VIS_LIN)
	ON_COMMAND(WINAMP_VIS_BAR, OnMessageWINAMP_VIS_BAR)
	ON_COMMAND(WINAMP_OPTIONS_MINIBROWSER, OnMessageWINAMP_OPTIONS_MINIBROWSER)
	ON_COMMAND(MB_FWD, OnMessageMB_FWD)
	ON_COMMAND(MB_BACK, OnMessageMB_BACK)
	ON_COMMAND(MB_RELOAD, OnMessageMB_RELOAD)
	ON_COMMAND(MB_OPENMENU, OnMessageMB_OPENMENU)
	ON_COMMAND(MB_OPENLOC, OnMessageMB_OPENLOC)
	ON_COMMAND(WINAMP_NEW_INSTANCE, OnMessageWINAMP_NEW_INSTANCE)
	ON_COMMAND(MB_UPDATE, OnMessageMB_UPDATE)
	ON_COMMAND(WINAMP_OPTIONS_WINDOWSHADE_EQ, OnMessageWINAMP_OPTIONS_WINDOWSHADE_EQ)
	ON_COMMAND(EQ_PANLEFT, OnMessageEQ_PANLEFT)
	ON_COMMAND(EQ_PANRIGHT, OnMessageEQ_PANRIGHT)
	ON_COMMAND(WINAMP_GETMORESKINS, OnMessageWINAMP_GETMORESKINS)
	ON_COMMAND(WINAMP_VIS_OPTIONS, OnMessageWINAMP_VIS_OPTIONS)
	ON_COMMAND(WINAMP_PE_SEARCH, OnMessageWINAMP_PE_SEARCH)
	ON_COMMAND(ID_PE_BOOKMARK, OnMessageID_PE_BOOKMARK)
	ON_COMMAND(WINAMP_EDIT_BOOKMARKS, OnMessageWINAMP_EDIT_BOOKMARKS)
	ON_COMMAND(WINAMP_MAKECURBOOKMARK, OnMessageWINAMP_MAKECURBOOKMARK)
	ON_COMMAND(ID_MAIN_PLAY_BOOKMARK_NONE, OnMessageID_MAIN_PLAY_BOOKMARK_NONE)
	ON_COMMAND(ID_MAIN_PLAY_AUDIOCD, OnMessageID_MAIN_PLAY_AUDIOCD)
	ON_COMMAND(ID_MAIN_PLAY_AUDIOCD2, OnMessageID_MAIN_PLAY_AUDIOCD2)
	ON_COMMAND(ID_MAIN_PLAY_AUDIOCD3, OnMessageID_MAIN_PLAY_AUDIOCD3)
	ON_COMMAND(ID_MAIN_PLAY_AUDIOCD4, OnMessageID_MAIN_PLAY_AUDIOCD4)
	ON_COMMAND(WINAMP_OPTIONS_VIDEO, OnMessageWINAMP_OPTIONS_VIDEO)
	ON_COMMAND(ID_VIDEOWND_ZOOMFULLSCREEN, OnMessageID_VIDEOWND_ZOOMFULLSCREEN)
	ON_COMMAND(ID_VIDEOWND_ZOOM100, OnMessageID_VIDEOWND_ZOOM100)
	ON_COMMAND(ID_VIDEOWND_ZOOM200, OnMessageID_VIDEOWND_ZOOM200)
	ON_COMMAND(ID_VIDEOWND_ZOOM50, OnMessageID_VIDEOWND_ZOOM50)
	ON_COMMAND(ID_VIDEOWND_VIDEOOPTIONS, OnMessageID_VIDEOWND_VIDEOOPTIONS)
	ON_COMMAND(WINAMP_MINIMIZE, OnMessageWINAMP_MINIMIZE)
	ON_COMMAND(ID_PE_FONTBIGGER, OnMessageID_PE_FONTBIGGER)
	ON_COMMAND(ID_PE_FONTSMALLER, OnMessageID_PE_FONTSMALLER)
	ON_COMMAND(WINAMP_VIDEO_TOGGLE_FS, OnMessageWINAMP_VIDEO_TOGGLE_FS)
	ON_COMMAND(WINAMP_VIDEO_TVBUTTON, OnMessageWINAMP_VIDEO_TVBUTTON)
	ON_COMMAND(WINAMP_LIGHTNING_CLICK, OnMessageWINAMP_LIGHTNING_CLICK)
	ON_COMMAND(ID_FILE_ADDTOLIBRARY, OnMessageID_FILE_ADDTOLIBRARY)
	ON_COMMAND(ID_HELP_HELPTOPICS, OnMessageID_HELP_HELPTOPICS)
	ON_COMMAND(ID_HELP_GETTINGSTARTED, OnMessageID_HELP_GETTINGSTARTED)
	ON_COMMAND(ID_HELP_WINAMPFORUMS, OnMessageID_HELP_WINAMPFORUMS)
	ON_COMMAND(ID_PLAY_VOLUMEUP, OnMessageID_PLAY_VOLUMEUP)
	ON_COMMAND(ID_PLAY_VOLUMEDOWN, OnMessageID_PLAY_VOLUMEDOWN)
	ON_COMMAND(ID_PEFILE_OPENPLAYLISTFROMLIBRARY_NOPLAYLISTSINLIBRARY, OnMessageID_PEFILE_OPENPLAYLISTFROMLIBRARY_NOPLAYLISTSINLIBRARY)
	ON_COMMAND(ID_PEFILE_ADDFROMLIBRARY, OnMessageID_PEFILE_ADDFROMLIBRARY)
	ON_COMMAND(ID_PEFILE_CLOSEPLAYLISTEDITOR, OnMessageID_PEFILE_CLOSEPLAYLISTEDITOR)
	ON_COMMAND(ID_PEPLAYLIST_PLAYLISTPREFERENCES, OnMessageID_PEPLAYLIST_PLAYLISTPREFERENCES)
	ON_COMMAND(ID_MLFILE_NEWPLAYLIST, OnMessageID_MLFILE_NEWPLAYLIST)
	ON_COMMAND(ID_MLFILE_LOADPLAYLIST, OnMessageID_MLFILE_LOADPLAYLIST)
	ON_COMMAND(ID_MLFILE_SAVEPLAYLIST, OnMessageID_MLFILE_SAVEPLAYLIST)
	ON_COMMAND(ID_MLFILE_ADDMEDIATOLIBRARY, OnMessageID_MLFILE_ADDMEDIATOLIBRARY)
	ON_COMMAND(ID_MLFILE_CLOSEMEDIALIBRARY, OnMessageID_MLFILE_CLOSEMEDIALIBRARY)
	ON_COMMAND(ID_MLVIEW_NOWPLAYING, OnMessageID_MLVIEW_NOWPLAYING)
	ON_COMMAND(ID_MLVIEW_LOCALMEDIA_ALLMEDIA, OnMessageID_MLVIEW_LOCALMEDIA_ALLMEDIA)
	ON_COMMAND(ID_MLVIEW_LOCALMEDIA_AUDIO, OnMessageID_MLVIEW_LOCALMEDIA_AUDIO)
	ON_COMMAND(ID_MLVIEW_LOCALMEDIA_VIDEO, OnMessageID_MLVIEW_LOCALMEDIA_VIDEO)
	ON_COMMAND(ID_MLVIEW_PLAYLISTS_NOPLAYLISTINLIBRARY, OnMessageID_MLVIEW_PLAYLISTS_NOPLAYLISTINLIBRARY)
	ON_COMMAND(ID_MLVIEW_INTERNETRADIO, OnMessageID_MLVIEW_INTERNETRADIO)
	ON_COMMAND(ID_MLVIEW_INTERNETTV, OnMessageID_MLVIEW_INTERNETTV)
	ON_COMMAND(ID_MLVIEW_LIBRARYPREFERENCES, OnMessageID_MLVIEW_LIBRARYPREFERENCES)
	ON_COMMAND(ID_MLVIEW_DEVICES_NOAVAILABLEDEVICE, OnMessageID_MLVIEW_DEVICES_NOAVAILABLEDEVICE)
	ON_COMMAND(ID_MLFILE_IMPORTCURRENTPLAYLIST, OnMessageID_MLFILE_IMPORTCURRENTPLAYLIST)
	ON_COMMAND(ID_MLVIEW_MEDIA, OnMessageID_MLVIEW_MEDIA)
	ON_COMMAND(ID_MLVIEW_PLAYLISTS, OnMessageID_MLVIEW_PLAYLISTS)
	ON_COMMAND(ID_MLVIEW_MEDIA_ALLMEDIA, OnMessageID_MLVIEW_MEDIA_ALLMEDIA)
	ON_COMMAND(ID_MLVIEW_DEVICES, OnMessageID_MLVIEW_DEVICES)
	ON_COMMAND(ID_FILE_SHOWLIBRARY, OnMessageID_FILE_SHOWLIBRARY)
	ON_COMMAND(ID_FILE_CLOSELIBRARY, OnMessageID_FILE_CLOSELIBRARY)
	ON_COMMAND(ID_POST_PLAY_PLAYLIST, OnMessageID_POST_PLAY_PLAYLIST)
	ON_COMMAND(ID_VIS_NEXT, OnMessageID_VIS_NEXT)
	ON_COMMAND(ID_VIS_PREV, OnMessageID_VIS_PREV)
	ON_COMMAND(ID_VIS_RANDOM, OnMessageID_VIS_RANDOM)
	ON_COMMAND(ID_MANAGEPLAYLISTS, OnMessageID_MANAGEPLAYLISTS)
	ON_COMMAND(ID_PREFS_SKIN_SWITCHTOSKIN, OnMessageID_PREFS_SKIN_SWITCHTOSKIN)
	ON_COMMAND(ID_PREFS_SKIN_DELETESKIN, OnMessageID_PREFS_SKIN_DELETESKIN)
	ON_COMMAND(ID_PREFS_SKIN_RENAMESKIN, OnMessageID_PREFS_SKIN_RENAMESKIN)
	ON_COMMAND(ID_VIS_FS, OnMessageID_VIS_FS)
	ON_COMMAND(ID_VIS_CFG, OnMessageID_VIS_CFG)
	ON_COMMAND(ID_VIS_MENU, OnMessageID_VIS_MENU)
	ON_COMMAND(ID_VIS_SET_FS_FLAG, OnMessageID_VIS_SET_FS_FLAG)
	ON_COMMAND(ID_PE_SHOWPLAYING, OnMessageID_PE_SHOWPLAYING)
	ON_COMMAND(ID_HELP_REGISTERWINAMPPRO, OnMessageID_HELP_REGISTERWINAMPPRO)
	ON_COMMAND(ID_PE_MANUAL_ADVANCE, OnMessageID_PE_MANUAL_ADVANCE)
	ON_COMMAND(WA_SONG_5_STAR_RATING, OnMessageWA_SONG_5_STAR_RATING)
	ON_COMMAND(WA_SONG_4_STAR_RATING, OnMessageWA_SONG_4_STAR_RATING)
	ON_COMMAND(WA_SONG_3_STAR_RATING, OnMessageWA_SONG_3_STAR_RATING)
	ON_COMMAND(WA_SONG_2_STAR_RATING, OnMessageWA_SONG_2_STAR_RATING)
	ON_COMMAND(WA_SONG_1_STAR_RATING, OnMessageWA_SONG_1_STAR_RATING)
	ON_COMMAND(WA_SONG_NO_RATING, OnMessageWA_SONG_NO_RATING)
	ON_COMMAND(PL_SONG_5_STAR_RATING, OnMessagePL_SONG_5_STAR_RATING)
	ON_COMMAND(PL_SONG_4_STAR_RATING, OnMessagePL_SONG_4_STAR_RATING)
	ON_COMMAND(PL_SONG_3_STAR_RATING, OnMessagePL_SONG_3_STAR_RATING)
	ON_COMMAND(PL_SONG_2_STAR_RATING, OnMessagePL_SONG_2_STAR_RATING)
	ON_COMMAND(PL_SONG_1_STAR_RATING, OnMessagePL_SONG_1_STAR_RATING)
	ON_COMMAND(PL_SONG_NO_RATING, OnMessagePL_SONG_NO_RATING)
	ON_COMMAND(AUDIO_TRACK_ONE, OnMessageAUDIO_TRACK_ONE)
	ON_COMMAND(VIDEO_TRACK_ONE, OnMessageVIDEO_TRACK_ONE)
	ON_WM_COPYDATA()
END_MESSAGE_MAP()
BOOL CWAEmuWnd::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pData)
{
	TRACE(_T("OnCopyData"));
	return TRUE;
}
LRESULT CWAEmuWnd::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	CString filename;
	COPYDATASTRUCT* copyData;
	int index = -1;
	if (this->IsWindowVisible())
	{
		if (pMainFrame->Created)
			if (SeekDialog == NULL || SeekDialog != NULL && SeekDialog->m_hWnd == NULL)
				SeekDialog = SeekDialog->getInstance();
	}
	switch (message)
	{
	case WM_COMMAND:
		TRACE(_T("WM_COMMAND %d %d\n"), wParam, lParam);
		if (lParam == 2)
		{
			/*
			** If you use SendMessage(hwnd_winamp,WM_COMMAND,MAKEWPARAM(WINAMP_BUTTON2,0),0);
			** after using IPC_SETPLAYLISTPOS then Winamp will start playing the file at 'position'.
			*/
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
			return TRUE;
		}
		break;
	case WM_WA_IPC:
		return WAEmuWnd->IamWinamp(message, wParam, lParam);
	case WM_QUIT:
		::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_FILE_QUIT, 0);
		return TRUE;
	case WM_PAINT:
		ShowWindow(SW_HIDE);
		if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
			SeekDialog->SaveWindowPosAndDestroy();
		return TRUE;
	case WM_WA_MPEG_EOF:
		TRACE(_T("WM_WA_MPEG_EOF\n"));
		::PostMessage(pMainFrame->m_hWnd, WM_WA_MPEG_EOF, 0, 0);
		return TRUE;
	case IPC_PLAYFILE:
		{
			enqueueFileWithMetaStruct* eFile = (enqueueFileWithMetaStruct*)lParam;
			pMainFrame->CurrentVolume = pVolume->GetCurrentVolume();
			filename = eFile->filename;
			TRACE(_T("IamWinamp IPC_PLAYFILE %s\n"), eFile->filename);
			index = m_PlaylistManager.GetIndex((LPCTSTR)eFile->filename);
			if (index == -1)
			{
				m_PlaylistManager.Add((LPCTSTR)eFile->filename);
				index = m_PlaylistManager.GetIndex((LPCTSTR)eFile->filename);
			}
			pMainFrame->Current = index;
			if (::SendMessage(WAEmuWnd->m_hWnd, WM_WA_IPC, 0, IPC_ISPLAYING) != PLAYER_MODE_CLOSE)
				::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
			stdIn->SetVolume(pMainFrame->CurrentVolume * 255 / 100);
			pMainFrame->UpdMBTR();
			return TRUE;
		}
	case WM_COPYDATA:
		TRACE(_T("WM_COPYDATA %d %d \n"), wParam, lParam);
		if (!lParam)
			return FALSE;
		copyData = (COPYDATASTRUCT *)lParam;
		switch (copyData->dwData)
		{
		case IPC_PE_INSERTFILENAME:
			{
				fileinfo* fi = (fileinfo*)copyData->lpData;
				int index = m_PlaylistManager.GetIndex((LPCTSTR)fi->file);
				CachedTag tmp((LPCTSTR)fi->file);
				TCHAR title[5000];
				title[0]=0;
				int length = 0;
				stdIn->GetFileInfo((TCHAR *)(LPCTSTR)fi->file, (TCHAR *)(LPCTSTR)title, &length);
				if(strlen(title)!=0) {
				tmp.SetTitle(title);
				} else {
					tmp.SetTitle(fi->file);
				}
				tmp.SetDuration(length);
				m_PlaylistManager.Add(tmp, index);
				return TRUE;
			}
		case IPC_PLAYFILE:
			{
				enqueueFileWithMetaStruct* eFile = new enqueueFileWithMetaStruct;
				eFile->filename = (TCHAR *)calloc(copyData->cbData + 1, sizeof(TCHAR *));
				lstrcpy((TCHAR *)eFile->filename, (TCHAR *)copyData->lpData);
				//eFile->filename[copyData->cbData] = 0;
				::SendMessage(WAEmuWnd->m_hWnd, IPC_PLAYFILE, 0, (WPARAM)eFile);
				delete eFile->filename;
				delete eFile;
				break;
			}
		default:
			break;
		}
		return TRUE;
	}
	return CFrameWnd::WindowProc(message, wParam, lParam);
}

LRESULT CWAEmuWnd::IamWinamp(UINT message, WPARAM wParam, LPARAM lParam)
{
	static TCHAR playListTitle[5000];
	static TCHAR* extList;
	LRESULT ret = TRUE;
	CString tmp, str, res, resToken;

	for (int i = 0; i < 10 && registerID[i] != 0; i++)
	{
		UINT tmpRegisterID = registerID[i];
		if (tmpRegisterID != 0 && lParam == tmpRegisterID)
		{
			TRACE(_T("IamWinamp RegisterWindowMessage %d %d %d\n"), message, lParam, wParam);   	
			ret = PostMessage(tmpRegisterID, wParam, NULL);
			TRACE(_T("IamWinamp RegisterWindowMessage %d\n"), ret); 	
			return (LRESULT)ret;
		}
	}
	switch (lParam)
	{
	case IPC_SETPLAYLISTPOS:
		TRACE(_T("IamWinamp IPC_SETPLAYLISTPOS %d\n"), wParam);
		pMainFrame->Current = wParam;
		return TRUE;
	case IPC_GET_SHUFFLE:
		TRACE(_T("IamWinamp IPC_GET_SHUFFLE\n"));
		return pMainFrame->ShuffleMode;
	case IPC_JUMPTOTIME:
		TRACE(_T("IamWinamp IPC_JUMPTOTIME %d\n"), wParam);
		stdIn->SetOutputTime(wParam);
		return TRUE;
	case IPC_CB_OUTPUTCHANGED:
		TRACE(_T("IamWinamp IPC_CB_OUTPUTCHANGED\n"));
		return TRUE;
	case IPC_GET_IVIDEOOUTPUT:
		TRACE(_T("IamWinamp IPC_GET_IVIDEOOUTPUT\n"));
		vidOut->ShowWindow(SW_NORMAL);
		return (LRESULT)iVidOut;
	case IPC_SETVOLUME:
		if (wParam == -666)
		{
			pMainFrame->CurrentVolume = pVolume->GetCurrentVolume();
			return pMainFrame->CurrentVolume * 255 / 100;
		}
		else
		{
			pMainFrame->CurrentVolume = wParam * 100 / 255;
			pVolume->SetCurrentVolume(pMainFrame->CurrentVolume);
			stdIn->SetVolume(pMainFrame->CurrentVolume * 255 / 100);
			if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
				SeekDialog->m_vol.SetPos(pMainFrame->CurrentVolume);
		}
		TRACE(_T("IamWinamp IPC_SETVOLUME %d \n"), pMainFrame->CurrentVolume);
		return TRUE;
	case IPC_SETPANNING:
		if (wParam == -666)
			return pMainFrame->CurrentPanning;
		else
		{
			pMainFrame->CurrentPanning = wParam;
			stdIn->SetPan(pMainFrame->CurrentPanning);
		}
		TRACE(_T("IamWinamp IPC_SETPANNING %d \n"), pMainFrame->CurrentPanning);
		return TRUE;
	case IPC_GETINFO:
		TRACE(_T("IamWinamp IPC_GETINFO\n"));
		/* (requires Winamp 2.05+)
																							** int inf=SendMessage(hwnd_winamp,WM_WA_IPC,mode,IPC_GETINFO);
																							** IPC_GETINFO returns info about the current playing song. The value
																							** it returns depends on the value of 'mode'.
																							** Mode 	 Meaning
																							** ------------------
																							** 0		 Samplerate (i.e. 44100)
																							** 1		 Bitrate  (i.e. 128)
																							** 2		 Channels (i.e. 2)
																							** 3 (5+)    Video LOWORD=w HIWORD=h
																							** 4 (5+)    > 65536, string (video description)
																							*/
		switch (wParam)
		{
		case 0:
			return infoBitrate;
			break;
		case 1:
			return infoSamplerate;
			break;
		case 2:
			return infoStereo; 
			break;
		case 3:
			return MAKEWORD(infoWidth, infoHeight);
			break;
		case 4:
			return (LRESULT)LPTSTR(infoTitle.GetString());
			break;
		}
		break;
	case IPC_GET_EXTENDED_FILE_INFO:
		TRACE(_T("IamWinamp IPC_GET_EXTENDED_FILE_INFO\n"));
	case IPC_GET_EXTENDED_FILE_INFO_HOOKABLE:
		{
			extendedFileInfoStruct* eFIS;

			eFIS = (extendedFileInfoStruct *)wParam;
			TRACE(_T("IamWinamp IPC_GET_EXTENDED_FILE_INFO_HOOKABLE %s \n"), eFIS->metadata);
			//Analyse du tag demand
			if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("artist")))
			{
				lstrcpy((TCHAR *)eFIS->ret, m_PlaylistManager.GetArtist(pMainFrame->Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetArtist(pMainFrame->Current).GetLength();
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("title")))
			{
				lstrcpy((TCHAR *)eFIS->ret, m_PlaylistManager.GetTitle(pMainFrame->Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetTitle(pMainFrame->Current).GetLength();
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("filename")))
			{
				lstrcpy((TCHAR *)eFIS->ret, m_PlaylistManager.GetFilenameExt(pMainFrame->Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetFilenameExt(pMainFrame->Current).GetLength();
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("album")))
			{
				lstrcpy((TCHAR *)eFIS->ret, m_PlaylistManager.GetAlbum(pMainFrame->Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetAlbum(pMainFrame->Current).GetLength();
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("comment")))
			{
				lstrcpy((TCHAR *)eFIS->ret, m_PlaylistManager.GetComment(pMainFrame->Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetComment(pMainFrame->Current).GetLength();
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("genre")))
			{
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("trackno")))
			{
				tmp.Format(_T("%d"), pMainFrame->Current);
				lstrcpy((TCHAR *)eFIS->ret, tmp.GetString());
				eFIS->retlen = tmp.GetLength();
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("year")))
			{
				lstrcpy((TCHAR *)eFIS->ret, m_PlaylistManager.GetYear(pMainFrame->Current).GetString());
				eFIS->retlen = m_PlaylistManager.GetYear(pMainFrame->Current).GetLength();
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("tracknumber")))
			{
				tmp.Format(_T("%.2d"), pMainFrame->Current);
				lstrcpy((TCHAR *)eFIS->ret, tmp.GetString());
				eFIS->retlen = tmp.GetLength();
			}
				//Nombre de fois ou on joue la piste
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("playcount")))
			{
				tmp.Format(_T("%d"), 0);
				lstrcpy((TCHAR *)eFIS->ret, tmp.GetString());
				eFIS->retlen = tmp.GetLength();
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("rating")))
			{
				return NULL;
			}
			else if (!_tcsicmp((TCHAR *)eFIS->metadata, _T("ratingstar")))
			{
				return NULL;
			}
			else
			{
				CString tmp, tmp2;
				tmp.Format(_T("%s"), eFIS->metadata);
				lstrcpy((TCHAR *)eFIS->ret, tmp.GetString());
				eFIS->retlen = tmp.GetLength();
			}
			return (LRESULT)eFIS;
		}
	case IPC_FORMAT_TITLE:
		{
			waFormatTitle* fTitle;

			fTitle = (waFormatTitle *)wParam;
			TRACE(_T("IPC_FORMATTITLE %s"), fTitle->spec);

			tagz_format((const char*)fTitle->spec, ((TAGFUNC)fTitle->TAGFUNC), ((TAGFREEFUNC)fTitle->TAGFREEFUNC), fTitle->p, (char*)fTitle->out,
						fTitle->out_len);
			TRACE(_T("IPC_FORMATTITLE %s"), fTitle->out);
			return TRUE;
		}
	case IPC_GETPLAYLISTFILE:
		{
			TRACE(_T("IamWinamp IPC_GETPLAYLISTFILE %d\n"), wParam);
			static TCHAR playListFile[5000];
			lstrcpy(playListFile, LPTSTR(m_PlaylistManager.GetPlaylist(wParam).GetString()));
			return (LRESULT)playListFile;
		}
	case IPC_GETVERSION:
		TRACE(_T("IamWinamp IPC_GETVERSION %d \n"), wParam);
		return 0x5010;
	case IPC_IS_PLAYING_VIDEO:
		TRACE(_T("IamWinamp IPC_IS_PLAYING_VIDEO %d \n"), wParam);
		return 0;
	case IPC_ISPLAYING:
		ret = stdIn->GetPlayerMode();
		//  		  TRACE(_T("IamWinamp IPC_ISPLAYING %d \n"), ret);
		return ret;
	case IPC_WRITEPLAYLIST:
		TRACE(_T("IamWinamp IPC_WRITEPLAYLIST %d \n"), wParam);
		if (m_PlaylistManager.GetSize() != 0)
		{
			pMainFrame->SaveThePlaylist();
		}
		return pMainFrame->Current;
	case IPC_WRITECONFIG:
		TRACE(_T("IamWinamp IPC_WRITECONFIG %d \n"), wParam);
		switch (wParam)
		{
		case 0:
			pMainFrame->SaveSettings();
			return TRUE;
		case 1:
			pMainFrame->SaveThePlaylist();
			return TRUE;
		case 2:
			pMainFrame->SaveSettings();
			pMainFrame->SaveThePlaylist();
			return TRUE;
		}
	case IPC_GETLISTPOS:
		TRACE(_T("IamWinamp IPC_GETLISTPOS %d\n"), wParam);
		if (m_PlaylistManager.GetSize() == 0)
			return 0;
		return pMainFrame->Current;
	case IPC_GETLISTLENGTH:
		TRACE(_T("IamWinamp IPC_GETLISTLENGTH\n"));
		return m_PlaylistManager.GetSize();
	case IPC_GETEQDATA:
		TRACE(_T("IamWinamp IPC_GETEQDATA %d\n"), wParam);
		if (wParam == 12)
			return 0;
		if (wParam == 11)
			return 0;
		return 31;
	case IPC_GETOUTPUTTIME:
		TRACE(_T("IamWinamp IPC_GETOUTPUTTIME %d \n"), wParam);
		if (m_PlaylistManager.GetSize() == 0)
			return 0;
		if (wParam == 0)
			return stdIn->GetOutputTime();
		else
			return stdIn->GetLength() / 1000;   				
	case IPC_GETPLAYLISTTITLE:
		TRACE(_T("IamWinamp IPC_GETPLAYLISTTITLE %d \n"), wParam);
		if (m_PlaylistManager.GetSize() == 0)
			return (LRESULT)"";
		lstrcpy(playListTitle, LPCTSTR(m_PlaylistManager.GetTitle(wParam)));
		return (LRESULT)playListTitle;
	case WINAMP_OPTIONS_EQ:
		//Equalizer
		TRACE(_T("IamWinamp WINAMP_OPTIONS_EQ %d \n"), wParam);
		if (EqualizerDlg == NULL || EqualizerDlg != NULL && EqualizerDlg->m_hWnd == NULL)
			EqualizerDlg = EqualizerDlg->getInstance();
		else if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd != NULL)
			EqualizerDlg->SaveWindowPosAndDestroy();
		return TRUE;
	case WINAMP_MAIN_WINDOW:
		//Minibar
		TRACE(_T("IamWinamp WINAMP_MAIN_WINDOW %d \n"), wParam);
		if (SeekDialog == NULL || SeekDialog != NULL && SeekDialog->m_hWnd == NULL)
			SeekDialog = SeekDialog->getInstance();
		else if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
			SeekDialog->SaveWindowPosAndDestroy();
		return TRUE;
	case WINAMP_FILE_REPEAT:
		//repeat
		TRACE(_T("IamWinamp WINAMP_FILE_REPEAT %d \n"), wParam);
		if (pMainFrame->m_Repeat == 0 && pMainFrame->m_RepeatTrack == 0)
			pMainFrame->m_Repeat = 1;
		else if (pMainFrame->m_Repeat == 1 && pMainFrame->m_RepeatTrack == 0)
		{
			pMainFrame->m_Repeat = 0;
			pMainFrame->m_RepeatTrack = 1;
		}
		else if (pMainFrame->m_Repeat == 0 && pMainFrame->m_RepeatTrack == 1)
			pMainFrame->m_RepeatTrack = 0;
		return TRUE;
	case WINAMP_FILE_SHUFFLE:
		//shuffle
		TRACE(_T("IamWinamp WINAMP_FILE_SHUFFLE %d \n"), wParam);
		if (pMainFrame->ShuffleMode == 1)
			pMainFrame->ShuffleMode = 0;
		else
			pMainFrame->ShuffleMode = 1;
		return TRUE;
	case IPC_REGISTER_WINAMP_IPCMESSAGE:
		{
			TRACE(_T("IamWinamp IPC_REGISTER_WINAMP_IPCMESSAGE %s \n"), wParam);
			UINT tmpRegisterID = ::RegisterWindowMessage((LPTSTR)wParam);
			TRACE(_T("IamWinamp IPC_REGISTER_WINAMP_IPCMESSAGE %d \n"), tmpRegisterID);
			int i = 0;
			for (i = 0; i < 10 && registerID[i] != 0; i++)
				;
			if (i != 10)
				registerID[i] = tmpRegisterID;
			return tmpRegisterID;
		}
	case IPC_GETINIFILE:
		TRACE(_T("IamWinamp IPC_GETINIFILE %d \n"), wParam);
		//  		  return (LRESULT) LPCTSTR(pMainFrame->ininame);
		{
			static char szWinampInipath[MAX_PATH] = "";
			if (*szWinampInipath == '\0')
			{
				GetModuleFileNameA(NULL, szWinampInipath, MAX_PATH - 1);
				char* szWalk = szWinampInipath + strlen(szWinampInipath) - 1;
				while ((szWalk > szWinampInipath) && (*szWalk != '.'))
					szWalk--;
				szWalk++;
				strcpy(szWalk, "ini");
			}
			return (LRESULT)szWinampInipath;
		}
	case IPC_GETINIDIRECTORY:
		{
			TRACE(_T("IamWinamp IPC_GETINIDIRECTORY %d \n"), wParam);
			static char szPluginInipath[MAX_PATH] = "";
			if (*szPluginInipath == '\0')
			{
				GetModuleFileNameA(NULL, szPluginInipath, MAX_PATH - 1);
				char* szWalk = szPluginInipath + strlen(szPluginInipath) - 1;
				while ((szWalk > szPluginInipath) && (*szWalk != '\\'))
					szWalk--;
				szWalk++;
				strcpy(szWalk, "Plugins\\");
			}
			return (LRESULT)szPluginInipath;
		}
	case IPC_ADD_PREFS_DLG:
		{
			TRACE(_T("IamWinamp IPC_ADD_PREFS_DLG %d \n"), wParam);
			prefs = (prefsDlgRec *)wParam;
			listPrefs.SetSize(listPrefs.GetSize() + 1);
			listPrefs[listPrefs.GetSize() - 1] = (CObject *)prefs;
			TRACE(_T("IamWinamp IPC_ADD_PREFS_DLG %s %d\n"), prefs->name, prefs->dlgID);
			return TRUE;
		}
	case IPC_REMOVE_PREFS_DLG:
		{
			TRACE(_T("IamWinamp IPC_REMOVE_PREFS_DLG %d \n"), wParam);
			prefs = (prefsDlgRec *)wParam;
			for (int i = 0; i < listPrefs.GetSize(); i++)
			{
				prefsDlgRec* prefsComp = (prefsDlgRec*)listPrefs[i];
				if (prefsComp == prefs)
				{
					listPrefs.RemoveAt(i);
					break;
				}
			}
			return TRUE;
		}
	case IPC_GETWND:
		TRACE(_T("IamWinamp IPC_GETWND %d \n"), wParam);
		switch (wParam)
		{
		case IPC_GETWND_EQ:
			break;
		case IPC_GETWND_PE:
			PlaylistDlg = PlaylistDlg->getInstance();
			return (LRESULT)PlaylistDlg->m_hWnd;
		case IPC_GETWND_MB:
			break;
		case IPC_GETWND_VIDEO:
			break;
		}

		return (LRESULT)NULL;
	case IPC_GET_EMBEDIF:
		TRACE(_T("IamWinamp IPC_GET_EMBEDIF %d \n"), wParam);
		return (LRESULT)(WAEmuWnd->m_hWnd);
	case IPC_GETUNCOMPRESSINTERFACE:
		TRACE(_T("IamWinamp IPC_GETUNCOMPRESSINTERFACE %d \n"), wParam);
		return (LRESULT)uncompress;
	case IPC_ISWNDVISIBLE:
		TRACE(_T("IamWinamp IPC_ISWNDVISIBLE %d \n"), wParam);
		return IsWindowVisible();
	case IPC_UPDTITLE:
		{
			TRACE(_T("IPC_UPDTITLE %d"), wParam);
			TCHAR title[MAX_PATH];
			int length_in_ms = 0;
			title[0]=0;
			stdIn->GetFileInfo(NULL, (TCHAR *)&title, &length_in_ms);
			CString strTitle;
			strTitle.Format(_T("%s"), title);
			CString filename = m_PlaylistManager.GetPlaylist(pMainFrame->Current);
			if(stdIn->IsOurFile((TCHAR *)(LPCTSTR)m_PlaylistManager.GetPlaylist(pMainFrame->Current)))
			{
				CString strComment = filename;
				CString strArtist = "";
				if(strTitle.Find(" - ") > 0 && strTitle.Find(" - ") < strTitle.ReverseFind('(') && strTitle.ReverseFind('(') > 0) {
					strArtist = strTitle.Left(strTitle.Find(" - "));
					strTitle = strTitle.Right(strTitle.GetLength() - strTitle.Find(" - ") - 3);
					strComment = strTitle.Right(strTitle.GetLength() - strTitle.Find('(') - 1);
					strTitle = strTitle.Left(strTitle.Find('(') - 1);
					if(strComment.Find(')')<strComment.Find('(')) {
						strComment = strComment.Left(strComment.Find(')'));
					} else {
						strComment = strComment.Left(strComment.ReverseFind(')'));
					}
				}
				m_PlaylistManager.SetComment(pMainFrame->Current, strComment);
				m_PlaylistManager.SetArtist(pMainFrame->Current, strArtist);
				m_PlaylistManager.SetTitle(pMainFrame->Current, strTitle);
				if (!pMainFrame->m_traytip.IsVisible())
					pMainFrame->DisplayTooltip();
			} else
			{
				if(strTitle.GetLength()!=0) {
					m_PlaylistManager.SetTitle(pMainFrame->Current, strTitle);
				}
				else {
					m_PlaylistManager.SetTitle(pMainFrame->Current, m_PlaylistManager.GetFilename(pMainFrame->Current));
				}
			}
			m_PlaylistManager.SetDuration(pMainFrame->Current, length_in_ms);
			return TRUE;
		}
	case IPC_OPENPREFSTOPAGE:
		TRACE(_T("IPC_OPENPREFSTOPAGE %d"), wParam);
		if (SettingsDialog == NULL || SettingsDialog != NULL && SettingsDialog->m_hWnd == NULL)
			SettingsDialog = SettingsDialog->getInstance();
		if (!SettingsDialog->IsWindowVisible())
			SettingsDialog->ShowWindow(SW_SHOW);
		if (wParam < 200)
			SettingsDialog->SetActivePage((int)wParam);
		else
			SettingsDialog->SetActivePage((prefsDlgRec *)wParam);
		return TRUE;
	case IPC_GET_EXTLIST:
		TRACE(_T("IPC_GET_EXTLIST %d"), wParam);
		extList = (TCHAR *)GlobalAlloc(GMEM_FIXED, 5000);
		tmp = stdIn->GetFileExtensions();
		tmp.MakeLower();
		_tcscpy(extList, tmp.GetString());
		for (int i = 0; i < 5000; i++)
		{
			if (extList[i] == ';')
				extList[i] = 0;
		}
		return (LRESULT)extList;
	case IPC_IS_FULLSCREEN:
		TRACE(_T("IamWinamp IPC_IS_FULLSCREEN %d \n"), wParam);
		return FALSE;
	case IPC_GET_GENSKINBITMAP:
		{
			TRACE(_T("IamWinamp IPC_GET_GENSKINBITMAP %d \n"), wParam);
			HBITMAP image = (HBITMAP)::LoadImage(theApp.m_hInstance, MAKEINTRESOURCE(IDB_GENSKIN), IMAGE_BITMAP, 0, 0,
												 LR_DEFAULTCOLOR || LR_DEFAULTSIZE);
			return (LRESULT)image;
		}
	case IPC_GETSKIN:
		{
			TRACE(_T("IamWinamp IPC_GETSKIN %s \n"), wParam);
			TCHAR* p = (TCHAR*)wParam;
			TCHAR szPath[MAX_PATH] = _T("");
			if (*szPath == '\0')
			{
				GetTempPath(MAX_PATH - 1, szPath);
				TCHAR szPathGen[MAX_PATH] = _T("");
				_tcscpy(szPathGen, szPath);
				_tcscat(szPathGen, _T("GEN.bmp"));
				HANDLE hFile = CreateFile(szPathGen, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL,
										  NULL);
				HRSRC hRes = (HRSRC)::FindResource(theApp.m_hInstance, MAKEINTRESOURCE(IDB_GEN), _T("IMAGE"));

				// loads the specified resource into global memory. 
				HGLOBAL hResourceLoaded = ::LoadResource(theApp.m_hInstance, hRes); 

				// get a pointer to the loaded resource!
				char* lpResLock;				// pointer to resource data 
				lpResLock = (char*)LockResource(hResourceLoaded); 

				DWORD dwWriteSize, dwNumWritten;
				// determine the size of the resource, so we know how much to write out to file!  
				dwWriteSize = ::SizeofResource(theApp.m_hInstance, hRes);
				WriteFile(hFile, (const char*)lpResLock, dwWriteSize, &dwNumWritten, NULL); 
				CloseHandle(hFile);
			}
			_tcscpy(p, szPath);
			return TRUE;
		}
	case IPC_GET_PROXY_STRING:
		return (LRESULT)"";
	default :
		TRACE(_T("Message non reu %d %d\n"), wParam, lParam);
	}
	return CFrameWnd::DefWindowProc(WM_WA_IPC, wParam, lParam);
}



void CWAEmuWnd::OnMessageWINAMP_FILE_QUIT()
{
	TRACE(_T("Command WINAMP_FILE_QUIT"));
	pMainFrame->Finish();
	AfxPostQuitMessage(0);
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_PREFS()
{
	TRACE(_T("Command WINAMP_OPTIONS_PREFS"));
	SettingsDialog->getInstance();
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_AOT()
{
	TRACE(_T("Command WINAMP_OPTIONS_AOT"));
}
void CWAEmuWnd::OnMessageWINAMP_FILE_REPEAT()
{
	TRACE(_T("Command WINAMP_FILE_REPEAT"));
	if (pMainFrame->m_RepeatTrack == 1)
		pMainFrame->m_RepeatTrack = 0;
	else
	{
		pMainFrame->m_RepeatTrack = 1;pMainFrame->m_Repeat = 0;
	}
}
void CWAEmuWnd::OnMessageWINAMP_FILE_SHUFFLE()
{
	TRACE(_T("Command WINAMP_FILE_SHUFFLE"));
	if (pMainFrame->ShuffleMode == 1)
		pMainFrame->ShuffleMode = 0;
	else
		pMainFrame->ShuffleMode = 1;
}
void CWAEmuWnd::OnMessageWINAMP_HIGH_PRIORITY()
{
	TRACE(_T("Command WINAMP_HIGH_PRIORITY"));
}
void CWAEmuWnd::OnMessageWINAMP_FILE_PLAY()
{
	TRACE(_T("Command WINAMP_FILE_PLAY"));
	if (pMainFrame->opening)
		return;
	pMainFrame->opening = true;
	//open a file

	CFileDialog dialog(TRUE, _T("mp3"), _T(""), OFN_ALLOWMULTISELECT | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, stdIn->GetFileExtensionsFilter());
	TCHAR buffer[_MAX_PATH*500 + 1];
	buffer[0] = '\0';
	dialog.m_ofn.lpstrFile = buffer;
	dialog.m_ofn.nMaxFile = _MAX_PATH * 500;
	dialog.m_ofn.lpstrInitialDir = LPCTSTR(pMainFrame->InitDir);
	int ret;
	ret = dialog.DoModal();
	if (ret == IDOK)
	{
		POSITION p = dialog.GetStartPosition();
		CString buf;
		bool q = false;
		while (p != NULL)
		{
			buf = dialog.GetNextPathName(p);
			pMainFrame->InitDir = buf.Left(buf.ReverseFind('\\') + 1);
			if ((buf.Right(4)).CompareNoCase(_T(".M3U")) == 0 || (buf.Right(4)).CompareNoCase(_T(".PLS")) == 0)
			{
				//a playlist was selected
				pMainFrame->OpenPlaylist(buf, (pMainFrame->RandomFirst == 1), (q == 1));
			}
			else
			{
				//a file was selected
				pMainFrame->OpenFile(buf, (q == 1));
			}
			pMainFrame->AddRecent(buf);
			q = true;
		}
	}
	pMainFrame->opening = false;
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_EQ()
{
	TRACE(_T("Command WINAMP_OPTIONS_EQ"));
	if (EqualizerDlg == NULL || EqualizerDlg != NULL && EqualizerDlg->m_hWnd == NULL)
		EqualizerDlg = EqualizerDlg->getInstance();
	else if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd != NULL)
		EqualizerDlg->SaveWindowPosAndDestroy();
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_ELAPSED()
{
	TRACE(_T("Command WINAMP_OPTIONS_ELAPSED"));
	pMainFrame->ShowRemainingTime = 0;     
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_REMAINING()
{
	TRACE(_T("Command WINAMP_OPTIONS_REMAINING"));
	pMainFrame->ShowRemainingTime = 1;
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_PLEDIT()
{
	TRACE(_T("Command WINAMP_OPTIONS_PLEDIT"));
	if (PlaylistDlg == NULL || PlaylistDlg != NULL && PlaylistDlg->m_hWnd == NULL)
		PlaylistDlg = PlaylistDlg->getInstance();
	else
		PlaylistDlg->SaveWindowPosAndDestroy();
}
void CWAEmuWnd::OnMessageWINAMP_HELP_ABOUT()
{
	TRACE(_T("Command WINAMP_HELP_ABOUT"));
	AboutDialog = AboutDialog->getInstance();
}
void CWAEmuWnd::OnMessageWINAMP_MAINMENU()
{
	TRACE(_T("Command WINAMP_MAINMENU"));
	pMainFrame->ShowPopup(1);
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON1()
{
	TRACE(_T("Command WINAMP_BUTTON1 OK"));
	//prev
	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);
	if (m_PlaylistManager.GetSize() < 2)
		return;
	UINT q = 0;
	do
	{
		q++;
		if (pMainFrame->ShuffleMode)
			pMainFrame->Current = pMainFrame->MyRandom(false);
		else
		{
			UINT b, e; 
			pMainFrame->GetAlbumRange(&b, &e);
			if (pMainFrame->Current == b)
				pMainFrame->Current = e;
			else
				pMainFrame->Current--;
		}
		::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
		break;
	}
	while (q < (UINT)m_PlaylistManager.GetSize() * 2);

	pMainFrame->UpdMBTR();
	if (PlaylistDlg != NULL && PlaylistDlg->m_hWnd != NULL)
		PlaylistDlg->m_playlistat.Invalidate();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON2()
{
	TRACE(_T("Command WINAMP_BUTTON2 OK"));
	//play
	if (m_PlaylistManager.GetSize() != 0)
		switch (stdIn->GetPlayerMode())
		{
		case PLAYER_MODE_CLOSE :
			pMainFrame->CurrentVolume = pVolume->GetCurrentVolume();
			stdIn->SetOutMod(stdOut->GetOut_Module());
			stdIn->SetVolume(pMainFrame->CurrentVolume * 255 / 100);
			stdIn->Play((TCHAR *)(LPCTSTR)m_PlaylistManager.GetPlaylist(pMainFrame->Current));
			stdIn->SetVolume(pMainFrame->CurrentVolume * 255 / 100);
			break;
		case PLAYER_MODE_PAUSED :
			stdIn->UnPause();
			break;
		case PLAYER_MODE_PLAYING :
			stdIn->Pause();
			break;
		}
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON3()
{
	TRACE(_T("Command WINAMP_BUTTON3 OK"));
	//pause
	if (m_PlaylistManager.GetSize() != 0)
		switch (stdIn->GetPlayerMode())
		{
		case PLAYER_MODE_CLOSE :
			::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
			break;
		case PLAYER_MODE_PAUSED :
			stdIn->UnPause();
			break;
		case PLAYER_MODE_PLAYING :
			stdIn->Pause();
			break;
		}
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON4()
{
	TRACE(_T("Command WINAMP_BUTTON4 OK"));
	//stop
	if (m_PlaylistManager.GetSize() == 0)
		return;
	if (stdIn->GetPlayerMode() != PLAYER_MODE_CLOSE)
		stdIn->Stop();
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON5()
{
	TRACE(_T("Command WINAMP_BUTTON5 OK"));
	//next

	::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON4, 0);

	UINT q = 0;
	do
	{
		q++;
		if (pMainFrame->ShuffleMode)
		{
			pMainFrame->Current = pMainFrame->MyRandom(true);
			if (pMainFrame->Current == pMainFrame->FirstInMyRandom && pMainFrame->m_Repeat != 1)
			{
				if (pMainFrame->TryToEnd())
					return;
				break;
			}
		}
		else
		{
			UINT b, e; 
			pMainFrame->GetAlbumRange(&b, &e);
			if (pMainFrame->Current == e)
			{
				pMainFrame->Current = b;
				if (pMainFrame->m_Repeat != 1)
				{
					if (pMainFrame->TryToEnd())
						return;
					break;
				}
			}
			else
				pMainFrame->Current++;
		}
		::SendMessage(WAEmuWnd->m_hWnd, WM_COMMAND, WINAMP_BUTTON2, 0);
		break;
	}
	while (q < (UINT)m_PlaylistManager.GetSize() * 2);

	pMainFrame->UpdMBTR();
	if (PlaylistDlg != NULL && PlaylistDlg->m_hWnd != NULL)
		PlaylistDlg->m_playlistat.Invalidate();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON1_SHIFT()
{
	//5 sec backward
	TRACE(_T("Command WINAMP_BUTTON1_SHIFT"));
	if (m_PlaylistManager.GetSize() > 0 && stdIn->isSeekable())
		stdIn->SetOutputTime(stdIn->GetOutputTime() - 5);
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON2_SHIFT()
{
	TRACE(_T("Command WINAMP_BUTTON2_SHIFT"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON3_SHIFT()
{
	TRACE(_T("Command WINAMP_BUTTON3_SHIFT"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON4_SHIFT()
{
	TRACE(_T("Command WINAMP_BUTTON4_SHIFT"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON5_SHIFT()
{
	//5 sec forward
	TRACE(_T("Command WINAMP_BUTTON5_SHIFT"));
	if (m_PlaylistManager.GetSize() > 0 && stdIn->isSeekable())
		stdIn->SetOutputTime(stdIn->GetOutputTime() + 5);
	pMainFrame->UpdMBTR();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON1_CTRL()
{
	TRACE(_T("Command WINAMP_BUTTON1_CTRL"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON2_CTRL()
{
	//open URL
	TRACE(_T("Command WINAMP_BUTTON2_CTRL"));
	pMainFrame->OnPopupMenuOpenUrl();
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON3_CTRL()
{
	TRACE(_T("Command WINAMP_BUTTON3_CTRL"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON4_CTRL()
{
	TRACE(_T("Command WINAMP_BUTTON4_CTRL"));
}
void CWAEmuWnd::OnMessageWINAMP_BUTTON5_CTRL()
{
	TRACE(_T("Command WINAMP_BUTTON5_CTRL"));
}
void CWAEmuWnd::OnMessageWINAMP_VOLUMEUP()
{
	TRACE(_T("Command WINAMP_VOLUMEUP OK"));
	//vol up
	pMainFrame->CurrentVolume = pVolume->GetCurrentVolume();
	pMainFrame->CurrentVolume += (5 * 100 / 255);
	if (pMainFrame->CurrentVolume > 100)
		pMainFrame->CurrentVolume = 100;
	pVolume->SetCurrentVolume(pMainFrame->CurrentVolume);
	stdIn->SetVolume(pMainFrame->CurrentVolume * 255 / 100);
	if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
		SeekDialog->m_vol.SetPos(pMainFrame->CurrentVolume);
}
void CWAEmuWnd::OnMessageWINAMP_VOLUMEDOWN()
{
	TRACE(_T("Command WINAMP_VOLUMEDOWN OK"));
	//vol down
	pMainFrame->CurrentVolume = pVolume->GetCurrentVolume();
	pMainFrame->CurrentVolume -= (5 * 100 / 255);
	if (pMainFrame->CurrentVolume < 0)
		pMainFrame->CurrentVolume = 0;
	pVolume->SetCurrentVolume(pMainFrame->CurrentVolume);
	stdIn->SetVolume(pMainFrame->CurrentVolume * 255 / 100);
	if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
		SeekDialog->m_vol.SetPos(pMainFrame->CurrentVolume);
}
void CWAEmuWnd::OnMessageWINAMP_FFWD5S()
{
	TRACE(_T("Command WINAMP_FFWD5S"));
}
void CWAEmuWnd::OnMessageWINAMP_REW5S()
{
	TRACE(_T("Command WINAMP_REW5S"));
}
void CWAEmuWnd::OnMessageWINAMP_NEXT_WINDOW()
{
	TRACE(_T("Command WINAMP_NEXT_WINDOW"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_WINDOWSHADE()
{
	TRACE(_T("Command WINAMP_OPTIONS_WINDOWSHADE"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_DSIZE()
{
	TRACE(_T("Command WINAMP_OPTIONS_DSIZE"));
}
void CWAEmuWnd::OnMessageIDC_SORT_FILENAME()
{
	TRACE(_T("Command IDC_SORT_FILENAME"));
}
void CWAEmuWnd::OnMessageIDC_SORT_FILETITLE()
{
	TRACE(_T("Command IDC_SORT_FILETITLE"));
}
void CWAEmuWnd::OnMessageIDC_SORT_ENTIREFILENAME()
{
	TRACE(_T("Command IDC_SORT_ENTIREFILENAME"));
}
void CWAEmuWnd::OnMessageIDC_SELECTALL()
{
	TRACE(_T("Command IDC_SELECTALL"));
}
void CWAEmuWnd::OnMessageIDC_SELECTNONE()
{
	TRACE(_T("Command IDC_SELECTNONE"));
}
void CWAEmuWnd::OnMessageIDC_SELECTINV()
{
	TRACE(_T("Command IDC_SELECTINV"));
}
void CWAEmuWnd::OnMessageIDM_EQ_LOADPRE()
{
	TRACE(_T("Command IDM_EQ_LOADPRE"));
}
void CWAEmuWnd::OnMessageIDM_EQ_LOADMP3()
{
	TRACE(_T("Command IDM_EQ_LOADMP3"));
}
void CWAEmuWnd::OnMessageIDM_EQ_LOADDEFAULT()
{
	TRACE(_T("Command IDM_EQ_LOADDEFAULT"));
}
void CWAEmuWnd::OnMessageIDM_EQ_SAVEPRE()
{
	TRACE(_T("Command IDM_EQ_SAVEPRE"));
}
void CWAEmuWnd::OnMessageIDM_EQ_SAVEMP3()
{
	TRACE(_T("Command IDM_EQ_SAVEMP3"));
}
void CWAEmuWnd::OnMessageIDM_EQ_SAVEDEFAULT()
{
	TRACE(_T("Command IDM_EQ_SAVEDEFAULT"));
}
void CWAEmuWnd::OnMessageIDM_EQ_DELPRE()
{
	TRACE(_T("Command IDM_EQ_DELPRE"));
}
void CWAEmuWnd::OnMessageIDM_EQ_DELMP3()
{
	TRACE(_T("Command IDM_EQ_DELMP3"));
}
void CWAEmuWnd::OnMessageIDC_PLAYLIST_PLAY()
{
	TRACE(_T("Command IDC_PLAYLIST_PLAY"));
}
void CWAEmuWnd::OnMessageWINAMP_FILE_LOC()
{
	TRACE(_T("Command WINAMP_FILE_LOC"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_EASYMOVE()
{
	TRACE(_T("Command WINAMP_OPTIONS_EASYMOVE"));
}
void CWAEmuWnd::OnMessageWINAMP_FILE_DIR()
{
	TRACE(_T("Command WINAMP_FILE_DIR"));
}
void CWAEmuWnd::OnMessageWINAMP_EDIT_ID3()
{
	TRACE(_T("Command WINAMP_EDIT_ID3"));
}
void CWAEmuWnd::OnMessageWINAMP_TOGGLE_AUTOSCROLL()
{
	TRACE(_T("Command WINAMP_TOGGLE_AUTOSCROLL"));
}
void CWAEmuWnd::OnMessageWINAMP_VISSETUP()
{
	TRACE(_T("Command WINAMP_VISSETUP"));
}
void CWAEmuWnd::OnMessageWINAMP_PLGSETUP()
{
	TRACE(_T("Command WINAMP_PLGSETUP"));
}
void CWAEmuWnd::OnMessageWINAMP_VISPLUGIN()
{
	TRACE(_T("Command WINAMP_VISPLUGIN"));
}
void CWAEmuWnd::OnMessageWINAMP_JUMP()
{
	TRACE(_T("Command WINAMP_JUMP"));
}
void CWAEmuWnd::OnMessageWINAMP_JUMPFILE()
{
	TRACE(_T("Command WINAMP_JUMPFILE"));
	if (PlaylistDlg == NULL || PlaylistDlg != NULL && PlaylistDlg->m_hWnd == NULL)
		PlaylistDlg = PlaylistDlg->getInstance();
	else
		PlaylistDlg->SetFocus();
}
void CWAEmuWnd::OnMessageWINAMP_JUMP10FWD()
{
	TRACE(_T("Command WINAMP_JUMP10FWD"));
}
void CWAEmuWnd::OnMessageWINAMP_JUMP10BACK()
{
	TRACE(_T("Command WINAMP_JUMP10BACK"));
}
void CWAEmuWnd::OnMessageWINAMP_PREVSONG()
{
	TRACE(_T("Command WINAMP_PREVSONG"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_EXTRAHQ()
{
	TRACE(_T("Command WINAMP_OPTIONS_EXTRAHQ"));
}
void CWAEmuWnd::OnMessageID_PE_NEW()
{
	TRACE(_T("Command ID_PE_NEW"));
}
void CWAEmuWnd::OnMessageID_PE_OPEN()
{
	TRACE(_T("Command ID_PE_OPEN"));
}
void CWAEmuWnd::OnMessageID_PE_SAVE()
{
	TRACE(_T("Command ID_PE_SAVE"));
}
void CWAEmuWnd::OnMessageID_PE_SAVEAS()
{
	TRACE(_T("Command ID_PE_SAVEAS"));
}
void CWAEmuWnd::OnMessageID_PE_SELECTALL()
{
	TRACE(_T("Command ID_PE_SELECTALL"));
}
void CWAEmuWnd::OnMessageID_PE_INVERT()
{
	TRACE(_T("Command ID_PE_INVERT"));
}
void CWAEmuWnd::OnMessageID_PE_NONE()
{
	TRACE(_T("Command ID_PE_NONE"));
}
void CWAEmuWnd::OnMessageID_PE_ID3()
{
	TRACE(_T("Command ID_PE_ID3"));
}
void CWAEmuWnd::OnMessageID_PE_S_TITLE()
{
	TRACE(_T("Command ID_PE_S_TITLE"));
}
void CWAEmuWnd::OnMessageID_PE_S_FILENAME()
{
	TRACE(_T("Command ID_PE_S_FILENAME"));
}
void CWAEmuWnd::OnMessageID_PE_S_PATH()
{
	TRACE(_T("Command ID_PE_S_PATH"));
}
void CWAEmuWnd::OnMessageID_PE_S_RANDOM()
{
	TRACE(_T("Command ID_PE_S_RANDOM"));
}
void CWAEmuWnd::OnMessageID_PE_S_REV()
{
	TRACE(_T("Command ID_PE_S_REV"));
}
void CWAEmuWnd::OnMessageID_PE_CLEAR()
{
	TRACE(_T("Command ID_PE_CLEAR"));
}
void CWAEmuWnd::OnMessageID_PE_MOVEUP()
{
	TRACE(_T("Command ID_PE_MOVEUP"));
}
void CWAEmuWnd::OnMessageID_PE_MOVEDOWN()
{
	TRACE(_T("Command ID_PE_MOVEDOWN"));
}
void CWAEmuWnd::OnMessageWINAMP_SELSKIN()
{
	TRACE(_T("Command WINAMP_SELSKIN"));
}
void CWAEmuWnd::OnMessageWINAMP_VISCONF()
{
	TRACE(_T("Command WINAMP_VISCONF"));
}
void CWAEmuWnd::OnMessageID_PE_NONEXIST()
{
	TRACE(_T("Command ID_PE_NONEXIST"));
}
void CWAEmuWnd::OnMessageID_PE_DELETEFROMDISK()
{
	TRACE(_T("Command ID_PE_DELETEFROMDISK"));
}
void CWAEmuWnd::OnMessageID_PE_CLOSE()
{
	TRACE(_T("Command ID_PE_CLOSE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SETOSC()
{
	TRACE(_T("Command WINAMP_VIS_SETOSC"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SETANA()
{
	TRACE(_T("Command WINAMP_VIS_SETANA"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SETOFF()
{
	TRACE(_T("Command WINAMP_VIS_SETOFF"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_DOTSCOPE()
{
	TRACE(_T("Command WINAMP_VIS_DOTSCOPE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_LINESCOPE()
{
	TRACE(_T("Command WINAMP_VIS_LINESCOPE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SOLIDSCOPE()
{
	TRACE(_T("Command WINAMP_VIS_SOLIDSCOPE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_NORMANA()
{
	TRACE(_T("Command WINAMP_VIS_NORMANA"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FIREANA()
{
	TRACE(_T("Command WINAMP_VIS_FIREANA"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_LINEANA()
{
	TRACE(_T("Command WINAMP_VIS_LINEANA"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_NORMVU()
{
	TRACE(_T("Command WINAMP_VIS_NORMVU"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_SMOOTHVU()
{
	TRACE(_T("Command WINAMP_VIS_SMOOTHVU"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FULLREF()
{
	TRACE(_T("Command WINAMP_VIS_FULLREF"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FULLREF2()
{
	TRACE(_T("Command WINAMP_VIS_FULLREF3"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FULLREF3()
{
	TRACE(_T("Command WINAMP_VIS_FULLREF3"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FULLREF4()
{
	TRACE(_T("Command WINAMP_VIS_FULLREF4"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_TOGTIME()
{
	TRACE(_T("Command WINAMP_OPTIONS_TOGTIME"));
}
void CWAEmuWnd::OnMessageEQ_ENABLE()
{
	TRACE(_T("Command EQ_ENABLE"));
}
void CWAEmuWnd::OnMessageEQ_AUTO()
{
	TRACE(_T("Command EQ_AUTO"));
}
void CWAEmuWnd::OnMessageEQ_PRESETS()
{
	TRACE(_T("Command EQ_PRESETS"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF0()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF0"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF1()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF1"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF2()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF2"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF3()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF3"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_FALLOFF4()
{
	TRACE(_T("Command WINAMP_VIS_FALLOFF4"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PEAKS()
{
	TRACE(_T("Command WINAMP_VIS_PEAKS"));
}
void CWAEmuWnd::OnMessageID_LOAD_EQF()
{
	TRACE(_T("Command ID_LOAD_EQF"));
}
void CWAEmuWnd::OnMessageID_SAVE_EQF()
{
	TRACE(_T("Command ID_SAVE_EQF"));
}
void CWAEmuWnd::OnMessageID_PE_ENTRY()
{
	TRACE(_T("Command ID_PE_ENTRY"));
}
void CWAEmuWnd::OnMessageID_PE_SCROLLUP()
{
	TRACE(_T("Command ID_PE_SCROLLUP"));
}
void CWAEmuWnd::OnMessageID_PE_SCROLLDOWN()
{
	TRACE(_T("Command ID_PE_SCROLLDOWN"));
}
void CWAEmuWnd::OnMessageWINAMP_MAIN_WINDOW()
{
	TRACE(_T("Command WINAMP_MAIN_WINDOW"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF0()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF0"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF1()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF1"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF2()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF2"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF3()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF3"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_PFALLOFF4()
{
	TRACE(_T("Command WINAMP_VIS_PFALLOFF4"));
}
void CWAEmuWnd::OnMessageID_PE_TOP()
{
	TRACE(_T("Command ID_PE_TOP"));
}
void CWAEmuWnd::OnMessageID_PE_BOTTOM()
{
	TRACE(_T("Command ID_PE_BOTTOM"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_WINDOWSHADE_PL()
{
	TRACE(_T("Command WINAMP_OPTIONS_WINDOWSHADE_PL"));
}
void CWAEmuWnd::OnMessageEQ_INC1()
{
	TRACE(_T("Command EQ_INC1"));
}
void CWAEmuWnd::OnMessageEQ_INC2()
{
	TRACE(_T("Command EQ_INC2"));
}
void CWAEmuWnd::OnMessageEQ_INC3()
{
	TRACE(_T("Command EQ_INC3"));
}
void CWAEmuWnd::OnMessageEQ_INC4()
{
	TRACE(_T("Command EQ_INC4"));
}
void CWAEmuWnd::OnMessageEQ_INC5()
{
	TRACE(_T("Command EQ_INC5"));
}
void CWAEmuWnd::OnMessageEQ_INC6()
{
	TRACE(_T("Command EQ_INC6"));
}
void CWAEmuWnd::OnMessageEQ_INC7()
{
	TRACE(_T("Command EQ_INC7"));
}
void CWAEmuWnd::OnMessageEQ_INC8()
{
	TRACE(_T("Command EQ_INC8"));
}
void CWAEmuWnd::OnMessageEQ_INC9()
{
	TRACE(_T("Command EQ_INC9"));
}
void CWAEmuWnd::OnMessageEQ_INC10()
{
	TRACE(_T("Command EQ_INC10"));
}
void CWAEmuWnd::OnMessageEQ_INCPRE()
{
	TRACE(_T("Command EQ_INCPRE"));
}
void CWAEmuWnd::OnMessageEQ_DECPRE()
{
	TRACE(_T("Command EQ_DECPRE"));
}
void CWAEmuWnd::OnMessageEQ_DEC1()
{
	TRACE(_T("Command EQ_DEC1"));
}
void CWAEmuWnd::OnMessageEQ_DEC2()
{
	TRACE(_T("Command EQ_DEC2"));
}
void CWAEmuWnd::OnMessageEQ_DEC3()
{
	TRACE(_T("Command EQ_DEC3"));
}
void CWAEmuWnd::OnMessageEQ_DEC4()
{
	TRACE(_T("Command EQ_DEC4"));
}
void CWAEmuWnd::OnMessageEQ_DEC5()
{
	TRACE(_T("Command EQ_DEC5"));
}
void CWAEmuWnd::OnMessageEQ_DEC6()
{
	TRACE(_T("Command EQ_DEC6"));
}
void CWAEmuWnd::OnMessageEQ_DEC7()
{
	TRACE(_T("Command EQ_DEC7"));
}
void CWAEmuWnd::OnMessageEQ_DEC8()
{
	TRACE(_T("Command EQ_DEC8"));
}
void CWAEmuWnd::OnMessageEQ_DEC9()
{
	TRACE(_T("Command EQ_DEC9"));
}
void CWAEmuWnd::OnMessageEQ_DEC10()
{
	TRACE(_T("Command EQ_DEC10"));
}
void CWAEmuWnd::OnMessageID_PE_SCUP()
{
	TRACE(_T("Command ID_PE_SCUP"));
}
void CWAEmuWnd::OnMessageID_PE_SCDOWN()
{
	TRACE(_T("Command ID_PE_SCDOWN"));
}
void CWAEmuWnd::OnMessageWINAMP_REFRESHSKIN()
{
	TRACE(_T("Command WINAMP_REFRESHSKIN"));
}
void CWAEmuWnd::OnMessageID_PE_PRINT()
{
	TRACE(_T("Command ID_PE_PRINT"));
}
void CWAEmuWnd::OnMessageID_PE_EXTINFO()
{
	TRACE(_T("Command ID_PE_EXTINFO"));
}
void CWAEmuWnd::OnMessageWINAMP_PLAYLIST_ADVANCE()
{
	TRACE(_T("Command WINAMP_PLAYLIST_ADVANCE"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_LIN()
{
	TRACE(_T("Command WINAMP_VIS_LIN"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_BAR()
{
	TRACE(_T("Command WINAMP_VIS_BAR"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_MINIBROWSER()
{
	TRACE(_T("Command WINAMP_OPTIONS_MINIBROWSER"));
}
void CWAEmuWnd::OnMessageMB_FWD()
{
	TRACE(_T("Command MB_FWD"));
}
void CWAEmuWnd::OnMessageMB_BACK()
{
	TRACE(_T("Command MB_BACK"));
}
void CWAEmuWnd::OnMessageMB_RELOAD()
{
	TRACE(_T("Command MB_RELOAD"));
}
void CWAEmuWnd::OnMessageMB_OPENMENU()
{
	TRACE(_T("Command MB_OPENMENU"));
}
void CWAEmuWnd::OnMessageMB_OPENLOC()
{
	TRACE(_T("Command MB_OPENLOC"));
}
void CWAEmuWnd::OnMessageWINAMP_NEW_INSTANCE()
{
	TRACE(_T("Command WINAMP_NEW_INSTANCE"));
}
void CWAEmuWnd::OnMessageMB_UPDATE()
{
	TRACE(_T("Command MB_UPDATE"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_WINDOWSHADE_EQ()
{
	TRACE(_T("Command WINAMP_OPTIONS_WINDOWSHADE_EQ"));
}
void CWAEmuWnd::OnMessageEQ_PANLEFT()
{
	TRACE(_T("Command EQ_PANLEFT"));
}
void CWAEmuWnd::OnMessageEQ_PANRIGHT()
{
	TRACE(_T("Command EQ_PANRIGHT"));
}
void CWAEmuWnd::OnMessageWINAMP_GETMORESKINS()
{
	TRACE(_T("Command WINAMP_GETMORESKINS"));
}
void CWAEmuWnd::OnMessageWINAMP_VIS_OPTIONS()
{
	TRACE(_T("Command WINAMP_VIS_OPTIONS"));
}
void CWAEmuWnd::OnMessageWINAMP_PE_SEARCH()
{
	TRACE(_T("Command WINAMP_PE_SEARCH"));
}
void CWAEmuWnd::OnMessageID_PE_BOOKMARK()
{
	TRACE(_T("Command ID_PE_BOOKMARK"));
}
void CWAEmuWnd::OnMessageWINAMP_EDIT_BOOKMARKS()
{
	TRACE(_T("Command WINAMP_EDIT_BOOKMARKS"));
}
void CWAEmuWnd::OnMessageWINAMP_MAKECURBOOKMARK()
{
	TRACE(_T("Command WINAMP_MAKECURBOOKMARK"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_BOOKMARK_NONE()
{
	TRACE(_T("Command ID_MAIN_PLAY_BOOKMARK_NONE"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_AUDIOCD()
{
	TRACE(_T("Command ID_MAIN_PLAY_AUDIOCD"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_AUDIOCD2()
{
	TRACE(_T("Command ID_MAIN_PLAY_AUDIOCD2"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_AUDIOCD3()
{
	TRACE(_T("Command ID_MAIN_PLAY_AUDIOCD3"));
}
void CWAEmuWnd::OnMessageID_MAIN_PLAY_AUDIOCD4()
{
	TRACE(_T("Command ID_MAIN_PLAY_AUDIOCD4"));
}
void CWAEmuWnd::OnMessageWINAMP_OPTIONS_VIDEO()
{
	TRACE(_T("Command WINAMP_OPTIONS_VIDEO"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_ZOOMFULLSCREEN()
{
	TRACE(_T("Command ID_VIDEOWND_ZOOMFULLSCREEN"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_ZOOM100()
{
	TRACE(_T("Command ID_VIDEOWND_ZOOM100"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_ZOOM200()
{
	TRACE(_T("Command ID_VIDEOWND_ZOOM200"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_ZOOM50()
{
	TRACE(_T("Command ID_VIDEOWND_ZOOM50"));
}
void CWAEmuWnd::OnMessageID_VIDEOWND_VIDEOOPTIONS()
{
	TRACE(_T("Command ID_VIDEOWND_VIDEOOPTIONS"));
}
void CWAEmuWnd::OnMessageWINAMP_MINIMIZE()
{
	TRACE(_T("Command WINAMP_MINIMIZE"));
}
void CWAEmuWnd::OnMessageID_PE_FONTBIGGER()
{
	TRACE(_T("Command ID_PE_FONTBIGGER"));
}
void CWAEmuWnd::OnMessageID_PE_FONTSMALLER()
{
	TRACE(_T("Command ID_PE_FONTSMALLER"));
}
void CWAEmuWnd::OnMessageWINAMP_VIDEO_TOGGLE_FS()
{
	TRACE(_T("Command WINAMP_VIDEO_TOGGLE_FS"));
}
void CWAEmuWnd::OnMessageWINAMP_VIDEO_TVBUTTON()
{
	TRACE(_T("Command WINAMP_VIDEO_TVBUTTON"));
}
void CWAEmuWnd::OnMessageWINAMP_LIGHTNING_CLICK()
{
	TRACE(_T("Command WINAMP_LIGHTNING_CLICK"));
}
void CWAEmuWnd::OnMessageID_FILE_ADDTOLIBRARY()
{
	TRACE(_T("Command ID_FILE_ADDTOLIBRARY"));
}
void CWAEmuWnd::OnMessageID_HELP_HELPTOPICS()
{
	TRACE(_T("Command ID_HELP_HELPTOPICS"));
}
void CWAEmuWnd::OnMessageID_HELP_GETTINGSTARTED()
{
	TRACE(_T("Command ID_HELP_GETTINGSTARTED"));
}
void CWAEmuWnd::OnMessageID_HELP_WINAMPFORUMS()
{
	TRACE(_T("Command ID_HELP_WINAMPFORUMS"));
}
void CWAEmuWnd::OnMessageID_PLAY_VOLUMEUP()
{
	TRACE(_T("Command ID_PLAY_VOLUMEUP"));
}
void CWAEmuWnd::OnMessageID_PLAY_VOLUMEDOWN()
{
	TRACE(_T("Command ID_PLAY_VOLUMEDOWN"));
}
void CWAEmuWnd::OnMessageID_PEFILE_OPENPLAYLISTFROMLIBRARY_NOPLAYLISTSINLIBRARY()
{
	TRACE(_T("Command ID_PEFILE_OPENPLAYLISTFROMLIBRARY_NOPLAYLISTSINLIBRARY"));
}
void CWAEmuWnd::OnMessageID_PEFILE_ADDFROMLIBRARY()
{
	TRACE(_T("Command ID_PEFILE_ADDFROMLIBRARY"));
}
void CWAEmuWnd::OnMessageID_PEFILE_CLOSEPLAYLISTEDITOR()
{
	TRACE(_T("Command ID_PEFILE_CLOSEPLAYLISTEDITOR"));
}
void CWAEmuWnd::OnMessageID_PEPLAYLIST_PLAYLISTPREFERENCES()
{
	TRACE(_T("Command ID_PEPLAYLIST_PLAYLISTPREFERENCES"));
}
void CWAEmuWnd::OnMessageID_MLFILE_NEWPLAYLIST()
{
	TRACE(_T("Command ID_MLFILE_NEWPLAYLIST"));
}
void CWAEmuWnd::OnMessageID_MLFILE_LOADPLAYLIST()
{
	TRACE(_T("Command ID_MLFILE_LOADPLAYLIST"));
}
void CWAEmuWnd::OnMessageID_MLFILE_SAVEPLAYLIST()
{
	TRACE(_T("Command ID_MLFILE_SAVEPLAYLIST"));
}
void CWAEmuWnd::OnMessageID_MLFILE_ADDMEDIATOLIBRARY()
{
	TRACE(_T("Command ID_MLFILE_ADDMEDIATOLIBRARY"));
}
void CWAEmuWnd::OnMessageID_MLFILE_CLOSEMEDIALIBRARY()
{
	TRACE(_T("Command ID_MLFILE_CLOSEMEDIALIBRARY"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_NOWPLAYING()
{
	TRACE(_T("Command ID_MLVIEW_NOWPLAYING"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_LOCALMEDIA_ALLMEDIA()
{
	TRACE(_T("Command ID_MLVIEW_LOCALMEDIA_ALLMEDIA"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_LOCALMEDIA_AUDIO()
{
	TRACE(_T("Command ID_MLVIEW_LOCALMEDIA_AUDIO"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_LOCALMEDIA_VIDEO()
{
	TRACE(_T("Command ID_MLVIEW_LOCALMEDIA_VIDEO"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_PLAYLISTS_NOPLAYLISTINLIBRARY()
{
	TRACE(_T("Command ID_MLVIEW_PLAYLISTS_NOPLAYLISTINLIBRARY"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_INTERNETRADIO()
{
	TRACE(_T("Command ID_MLVIEW_INTERNETRADIO"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_INTERNETTV()
{
	TRACE(_T("Command ID_MLVIEW_INTERNETTV"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_LIBRARYPREFERENCES()
{
	TRACE(_T("Command ID_MLVIEW_LIBRARYPREFERENCES"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_DEVICES_NOAVAILABLEDEVICE()
{
	TRACE(_T("Command ID_MLVIEW_DEVICES_NOAVAILABLEDEVICE"));
}
void CWAEmuWnd::OnMessageID_MLFILE_IMPORTCURRENTPLAYLIST()
{
	TRACE(_T("Command ID_MLFILE_IMPORTCURRENTPLAYLIST"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_MEDIA()
{
	TRACE(_T("Command ID_MLVIEW_MEDIA"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_PLAYLISTS()
{
	TRACE(_T("Command ID_MLVIEW_PLAYLISTS"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_MEDIA_ALLMEDIA()
{
	TRACE(_T("Command ID_MLVIEW_MEDIA_ALLMEDIA"));
}
void CWAEmuWnd::OnMessageID_MLVIEW_DEVICES()
{
	TRACE(_T("Command ID_MLVIEW_DEVICES"));
}
void CWAEmuWnd::OnMessageID_FILE_SHOWLIBRARY()
{
	TRACE(_T("Command ID_FILE_SHOWLIBRARY"));
}
void CWAEmuWnd::OnMessageID_FILE_CLOSELIBRARY()
{
	TRACE(_T("Command ID_FILE_CLOSELIBRARY"));
}
void CWAEmuWnd::OnMessageID_POST_PLAY_PLAYLIST()
{
	TRACE(_T("Command ID_POST_PLAY_PLAYLIST"));
}
void CWAEmuWnd::OnMessageID_VIS_NEXT()
{
	TRACE(_T("Command ID_VIS_NEXT"));
}
void CWAEmuWnd::OnMessageID_VIS_PREV()
{
	TRACE(_T("Command ID_VIS_PREV"));
}
void CWAEmuWnd::OnMessageID_VIS_RANDOM()
{
	TRACE(_T("Command ID_VIS_RANDOM"));
}
void CWAEmuWnd::OnMessageID_MANAGEPLAYLISTS()
{
	TRACE(_T("Command ID_MANAGEPLAYLISTS"));
}
void CWAEmuWnd::OnMessageID_PREFS_SKIN_SWITCHTOSKIN()
{
	TRACE(_T("Command ID_PREFS_SKIN_SWITCHTOSKIN"));
}
void CWAEmuWnd::OnMessageID_PREFS_SKIN_DELETESKIN()
{
	TRACE(_T("Command ID_PREFS_SKIN_DELETESKIN"));
}
void CWAEmuWnd::OnMessageID_PREFS_SKIN_RENAMESKIN()
{
	TRACE(_T("Command ID_PREFS_SKIN_RENAMESKIN"));
}
void CWAEmuWnd::OnMessageID_VIS_FS()
{
	TRACE(_T("Command ID_VIS_FS"));
}
void CWAEmuWnd::OnMessageID_VIS_CFG()
{
	TRACE(_T("Command ID_VIS_CFG"));
}
void CWAEmuWnd::OnMessageID_VIS_MENU()
{
	TRACE(_T("Command ID_VIS_MENU"));
}
void CWAEmuWnd::OnMessageID_VIS_SET_FS_FLAG()
{
	TRACE(_T("Command ID_VIS_SET_FS_FLAG"));
}
void CWAEmuWnd::OnMessageID_PE_SHOWPLAYING()
{
	TRACE(_T("Command ID_PE_SHOWPLAYING"));
}
void CWAEmuWnd::OnMessageID_HELP_REGISTERWINAMPPRO()
{
	TRACE(_T("Command ID_HELP_REGISTERWINAMPPRO"));
}
void CWAEmuWnd::OnMessageID_PE_MANUAL_ADVANCE()
{
	TRACE(_T("Command ID_PE_MANUAL_ADVANCE"));
}
void CWAEmuWnd::OnMessageWA_SONG_5_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_5_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_4_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_4_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_3_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_3_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_2_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_2_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_1_STAR_RATING()
{
	TRACE(_T("Command WA_SONG_1_STAR_RATING"));
}
void CWAEmuWnd::OnMessageWA_SONG_NO_RATING()
{
	TRACE(_T("Command WA_SONG_NO_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_5_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_5_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_4_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_4_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_3_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_3_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_2_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_2_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_1_STAR_RATING()
{
	TRACE(_T("Command PL_SONG_1_STAR_RATING"));
}
void CWAEmuWnd::OnMessagePL_SONG_NO_RATING()
{
	TRACE(_T("Command PL_SONG_NO_RATING"));
}
void CWAEmuWnd::OnMessageAUDIO_TRACK_ONE()
{
	TRACE(_T("Command AUDIO_TRACK_ONE"));
}
void CWAEmuWnd::OnMessageVIDEO_TRACK_ONE()
{
	TRACE(_T("Command VIDEO_TRACK_ONE"));
}
